//
// Caching.js
// FernsehWidget
// Vom Pascal Pfiffner und Sebastian Krau
//


var cacheBase;
var bgCacheReturnFunction;
var bgCacheShows;
var bgCacheRequest;
var bgCachedShows;
var bgCacheListingDay;
var bgCacheChannel;
var bgCacheChannelArray;
var cacheFurtherURL;
var parseErrorOccurred;
var networkErrorOccurred = false;
var weMayCache = true;
var didActuallyLoad = false;
//var wasFirstHalfOfDay;
var cachingDate;
var myCookie;
var hasMoreLink;
var wasPreviousDay;
var lastEncounteredHour;
var saveLastEncounteredHour;
var isCurrentlyLoadingListing;
var bgOffsetIndex;


function localUrl(channel, listingday)
{
	var date = new Date();
	listingday = parseInt(listingday);
	if (listingday == 8) listingday = -1;
	
	date.setTime(date.getTime() + (listingday * 86400000));
	localurl = cacheBase + (date.getMonth() + 1) + "-" + date.getDate() + "-" + channel;
		
	return localurl;
}

function clearCache()
{
	// Clearing the cache is a matter of fractions of a second, however, it is nice to give some feedback, so fake it
	document.getElementById("clear_cache_button").style.opacity = 0.4;
	setTimeout('document.getElementById("clear_cache_button").style.opacity = 1;', 500);
	FernsehPlugin.emptyCache();
}

//
// returns whether cached data is available for all channels
//
function cachedDataAvailable(channels, listingday)
{
	var channel;
	var y;
	for (y = 0; y < channels.length; y++)
	{
		channel = channels[y];
		var channelshows = FernsehPlugin.cat(localUrl(channel, listingday));
		if ((undefined == channelshows) || ("" == channelshows))
		{
			debug(channel + " at listingday " + listingday + " NOT available");
			return false;
		}
		debug(channel + " at listingday " + listingday + " available");
	}
	return true;
}

//
// Asynchronous caching
// Note: takes an array of channels
//
function backgroundCachedData(channels, listingday, returnFunc)
{
	var everythingThere = true;
	var channel;
	if (listingday >= 0)
	{
		// check whether a network error occurred. if yes, the returnfunction deals with it
		if (networkErrorOccurred)
		{
			returnFunc();
			bgCacheChannelArray = undefined;
			stopCacheIndicator();
			return;
		}
	
		bgCacheReturnFunction = returnFunc;
		parseErrorOccurred = false;
		
		var bgCacheShows = new Object();
		
		var everythingThere = true;
		
		var i;
		for (i = 0; i < channels.length; i++)
		{
			channel = channels[i];
			if ((undefined == channel) || (null == channel)) continue;
			var channelshows = loadShows(localUrl(channel, listingday));
			if (undefined == channelshows)
			{
				everythingThere = false;
				break;
			}
			bgCacheShows[channel] = channelshows;
		}
		
		bgCacheChannelArray = channels;
	} else everythingThere = true;
	
	if (everythingThere)
	{	
		returnFunc();
		stopCacheIndicator();
		return;
	} else {
		// else cache them and then return them
		startCacheIndicator();
		setCacheIndicatorText("Lade " + channelNameFromInternalName(parseChannelName(channel)));
		loadInBackground(channel, listingday);
	}
}

function dataUrl(listingday, channel, offset)
{
	var date = new Date();
	listingday = parseInt(listingday);
	
	if (8 == listingday) listingday = -1;
	date.setTime(date.getTime() + (listingday * 86400000));
		
	localurl = cacheBase + (date.getMonth() + 1) + "-" + date.getDate() + "-" + channel;
	var day = date.getDate();
	cachingDate = date;
	if (day < 10) day = "0" + day;
	var month = date.getMonth() + 1;
	if (month < 10) month = "0" + month;
	var year = date.getFullYear();
	var fulldate = day + "." + month + "." + year;
	
	var requesturl = "http://www.tvtoday.de/program2007?format=genre&offset=0&date="+fulldate+"&slotIndex=all&channel="+channel+"&tips=&order=time&offset="+offset;
	
	debug("requesturl: " + requesturl + " listingday " + listingday);
	return requesturl;
}

//
// Starts asynchronous loading
//
function loadInBackground(channel, listingday)
{
	lastEncounteredHour = 0;
	myCookie = "";
	if (!weMayCache) return;
	bgCacheChannel = channel;
	if (listingday == 8) listingday = -1;
	bgCacheListingDay = parseInt(listingday);
	networkErrorOccurred = false;
	
	bgCachedShows = new Object();
	bgOffsetIndex = 0;
	var requesturl = dataUrl(bgCacheListingDay-1, channel, bgOffsetIndex);
	wasPreviousDay = true;

	isCurrentlyLoadingListing = true;
	bgCacheRequest = new XMLHttpRequest;
	bgCacheRequest.onreadystatechange = bgProcessReqChange;
	bgCacheRequest.open("GET", requesturl, true);
	bgCacheRequest.setRequestHeader("Cache-Control", "no-cache");
	bgCacheRequest.setRequestHeader('User-Agent','Fernsehen Widget 1.8 widgetschmie.de/widgets/Fernsehen');
	bgCacheRequest.send(null);
}

function bgProcessReqChange()
{
	if (parseErrorOccurred) return;
	if (bgCacheRequest.readyState != 4) return;

	if ((!((bgCacheRequest.status >= 200) && (bgCacheRequest.status < 400))) || (bgCacheRequest.status == undefined))
	{
		networkErrorOccurred = true;
		bgCacheChannel = null;
		backgroundCachedData(bgCacheChannelArray, bgCacheListingDay, bgCacheReturnFunction);
		stopCacheIndicator();
		isCurrentlyLoadingListing = false;
		return;
	}
	networkErrorOccurred = false;
	isCurrentlyLoadingListing = false;
	
	if ("" == myCookie)
	{
		myCookie = bgCacheRequest.getResponseHeader("Set-Cookie");
		if (undefined == myCookie)
		{
			myCookie = "";
			alert("found no cookie, got no session id, nobody likes me, giving up.");
			backgroundCachedData(bgCacheChannelArray, bgCacheListingDay, bgCacheReturnFunction);
			stopCacheIndicator();
			return;
		}
	}
	
	var newShows = parseShows(bgCacheRequest.responseText, bgCacheListingDay, !wasPreviousDay);

	if (undefined == newShows)
	{
		networkErrorOccurred = true;
		alert("parseShows() was unsuccessful, abort caching here");
		bgCacheChannel = null;
		backgroundCachedData(bgCacheChannelArray, bgCacheListingDay, bgCacheReturnFunction);
		return;
	}
	
	for (var time in newShows)
	{
		bgCachedShows[time] = newShows[time];			
	}
	
	if (!weMayCache) return;
	
	if (hasMoreLink)
	{
		isCurrentlyLoadingListing = true;
		bgCacheRequest = new XMLHttpRequest;
		bgCacheRequest.onreadystatechange = bgProcessReqChange;
		bgCacheRequest.open("GET", dataUrl(bgCacheListingDay-(wasPreviousDay ? 1 : 0), bgCacheChannel, ++bgOffsetIndex), true);
		debug("next");
		bgCacheRequest.setRequestHeader("Cache-Control", "no-cache");
		bgCacheRequest.setRequestHeader('User-Agent','Fernsehen Widget 1.8 widgetschmie.de/widgets/Fernsehen');
		bgCacheRequest.setRequestHeader("Cookie", myCookie);
		bgCacheRequest.send(null);
	} else if (!hasMoreLink && wasPreviousDay) {
		bgOffsetIndex = 0;
		lastEncounteredHour = 0;
		var requesturl = dataUrl(bgCacheListingDay, bgCacheChannel, 0);
		wasPreviousDay = false;
		isCurrentlyLoadingListing = true;
		bgCacheRequest = new XMLHttpRequest;
		bgCacheRequest.onreadystatechange = bgProcessReqChange;
		bgCacheRequest.open("GET", requesturl, true);
		bgCacheRequest.setRequestHeader("Cache-Control", "no-cache");
		bgCacheRequest.setRequestHeader('User-Agent','Fernsehen Widget 1.8 widgetschmie.de/widgets/Fernsehen');
		bgCacheRequest.setRequestHeader("Cookie", myCookie);
		bgCacheRequest.send(null);
	} else {
		// We have all the data for a complete day
		debug("bgProcessReqChange complete");
		checkAlarmFilter(bgCachedShows, bgCacheChannel);
		saveShows(bgCachedShows, localUrl(bgCacheChannel, bgCacheListingDay));
		
		// call this function again, it knows what other channels have to be cached and calls the callback if all data has been loaded
		bgCacheChannel = null;
		backgroundCachedData(bgCacheChannelArray, bgCacheListingDay, bgCacheReturnFunction);
	}
}

//
// Synchronous caching
// Note: takes the name of one channel
//
function cachedData(channel, listingday)
{
	if ((undefined == channel) || (null == channel))
	{
		alert("undefined channel!");
		return;
	}
	
	var shows = loadShows(localUrl(channel, listingday));
	
	if (shows != undefined)
	{	
		return shows;
	} else {
		// else cache them and then return them
		startCacheIndicator();
		setCacheIndicatorText("Lade " + parseChannelName(channel));
		
		shows = cacheData(channel, listingday);
		stopCacheIndicator();
		if (undefined == shows)
		{
			// showError();
			return;
		} else {
			updateFilterBadge();
			return shows;
		}
	}
}


//
// Synchronous caching
//
function cacheData(channel, listingday)
{
	saveLastEncounteredHour = lastEncounteredHour;
	lastEncounteredHour = 0;
	
	var shows = new Object();
	
	if (undefined == listingday) return;
	if (undefined == channel) return;
	if (null == channel) return;
	
	listingday = parseInt(listingday);
	if (listingday == 8) listingday = -1;
	var request = new XMLHttpRequest;
	var offset = 0;
	var requesturl;
	
	do {
		requesturl = dataUrl(listingday-1, channel, offset++);
		request.open("GET", requesturl, false);
		request.setRequestHeader("Cache-Control", "no-cache");
		request.setRequestHeader('User-Agent','Fernsehen Widget 1.8 widgetschmie.de/widgets/Fernsehen');
		request.send(null);
		if (!((request.readyState == 4) && (request.status >= 200) && (request.status < 400))) return;
		if ("" == myCookie)
		{
			myCookie = request.getResponseHeader("Set-Cookie");
			if (undefined == myCookie)
			{
				myCookie = "";
				alert("found no cookie, got no session id, nobody likes me, giving up.");
				stopCacheIndicator();
				return;
			}
		}
		var newShows = parseShows(request.responseText, listingday, false);
		
		if (undefined == newShows)
		{
			alert("parseShows() was unsuccessful, abort caching here");
			return;
		}
		
		for (var time in newShows)
		{
			shows[time] = newShows[time];			
		}
	} while (hasMoreLink);
	
	// same thing for the next day
	// differences:
	// - listingday instead of listingday-1
	// - passes true instead of false to parseShows()
	offset = 0;
	lastEncounteredHour = 0;
	
	do {
		requesturl = dataUrl(listingday, channel, offset++);
		request.open("GET", requesturl, false);
		request.setRequestHeader("Cache-Control", "no-cache");
		request.setRequestHeader('User-Agent','Fernsehen Widget 1.8 widgetschmie.de/widgets/Fernsehen');
		request.send(null);
		if (!((request.readyState == 4) && (request.status >= 200) && (request.status < 400))) return;
		if ("" == myCookie)
		{
			myCookie = request.getResponseHeader("Set-Cookie");
			if (undefined == myCookie)
			{
				myCookie = "";
				alert("found no cookie, got no session id, nobody likes me, giving up.");
				stopCacheIndicator();
				return;
			}
		}
		var newShows = parseShows(request.responseText, listingday, true);
		
		if (undefined == newShows)
		{
			alert("parseShows() was unsuccessful, abort caching here");
			return;
		}
		
		for (var time in newShows)
		{
			shows[time] = newShows[time];			
		}
	} while (hasMoreLink);

	checkAlarmFilter(shows, channel);
	saveShows(shows, localUrl(channel, listingday));
	lastEncounteredHour = saveLastEncounteredHour;
	return shows;
}

function saveShows(shows, filename)
{
	var saveShows = new Object();
	for (var time in shows)
	{
		var variablesavetime = "_" + time.replace(/\./g, "_");
		saveShows[variablesavetime] = shows[time];
	}
	var serialized = Serialize(saveShows);
	var encoded = serialized.replace(/"/g, "&quot;");
	FernsehPlugin.saveCachedData(encoded, filename);
	debug("saving to "+filename);
}

//
// Load from disk
//
function loadShows(filename)
{
	// The plugin handles encoding and spaces in filenames better
	var file = FernsehPlugin.cat(filename);
	
	if ((undefined == file) || ("" == file)) {
		return;
	}
	
	var rawobject = file.replace(/&quot;/g, "\"");
	var deserialized = Deserialize(rawobject);
	var newObj = new Object();
	var foo;
	
	for(var key in deserialized) {
		foo = key.replace(/_/g, ".");
		newObj[foo.substr(1,5)] = deserialized[key];
	}
	
	return newObj;
}

function parseShows(rawsource, listingday, untilMidnight)
{
	// Das alles zu einer Zeile machen
	rsource = rawsource.replace(/\s/g, " ");
	
	var dateFirstShow;	
	var newShows = new Object();
	var doBreak = false;
	var inSecondHalf = false;
	//var lastEncounteredHour = 0;
	
	// abort if we got no valid data
	if (-1 != rawsource.indexOf("In diesem Zeitraum wurden zu Ihrer Auswahl leider keine Sendungen gefunden"))
	{
		alert("Ungueltige Suchanfrage an TVToday. Da muss ich passen, sorry.");
		alert("Moeglicherweise auch ein Fehler in der Datenbank von TVToday. Ich ignoriere das mal.");
		return newShows;
	}
	
	/***********************
	 * parsing starts here *
	 ***********************/
	
	try {
		
		// Der entscheidende Teil fr das Fernsehprogramm...
		rmatch = /<div id="program_complete">(.*?)<table align="right" border="0" cellpadding="5" cellspacing="0" class="tv-programm-blaettern">(.*)$/;
	
		rmatch.exec(rsource);
		var listing = RegExp.$1;
		debug((listing != undefined) ? "habe listing" : "habe KEIN listing! hier:\n"+rsource);
		
		shows = new Array();
		showsregexp = /<td width="45" style="border-right: 2px solid white; border-bottom: 2px solid white; border-left: 2px solid white; text-align:center;">(.*?)<\/a><br ?\/>\s*<\/td>\s*<\/tr>/g;
		
		rawshows = listing.match(showsregexp);
		
		debug("num shows " + (rawshows ? rawshows.length : "NONE"));
		
		var startstamp;
		var searchdate;
		var newShows = new Object();
		
		if (8 == listingday) listingday = -1;
		
		// Loop through the single shows
		var lastStartTime;
		var debugMessageCollection = '--- debugMessageCollection\n';
		
		for (i = 0; i < rawshows.length; i++)
		{
			iconurlregexp = /<img src="([^"]*)" id="channel_logo_[^"]*" alt="[^"]*" class="channel_logo" *\/>/;
			iconurlraw = rawshows[i].match(iconurlregexp);
			iconurl = iconurlraw[1];
			
			debugMessageCollection += "--- 1: " + iconurl + "\n";
			
			/*******************************
			 * Start the Date/Time parsing *
			 *******************************/
			
			// RegExp to get the time from tvtoday
			starttimeregexp = /<span class="tv-sendung-uhrzeit">([0-9.]*)<br *\/>-<br *\/>([0-9.]*)<\/span>/;
			starttimeraw = rawshows[i].match(starttimeregexp);
			starttime = starttimeraw[1];
			
			debugMessageCollection += "--- 2: " + starttime + "\n";
			
			// End Date/Time
			
			shownameregexp = /<td style="border-bottom: 2px solid white;"><a href="javascript: detailPopup\('\d+'\);" class="tv-sendung-titel">([^<]*)<\/a>/;
			shownameraw = rawshows[i].match(shownameregexp);
			showname = shownameraw[1];
			
			debugMessageCollection += "--- 3: " + showname + "\n";

			showurlregexp = /<td style="border-bottom: 2px solid white;"><a href="javascript: detailPopup\('(\d+)'\);" class="tv-sendung-titel">/; 
			showurlraw = rawshows[i].match(showurlregexp);
			var showurl = null;
			if (showurlraw != null) showurl = "http://www.tvtoday.de/program2007\?format=detail&sid=" + showurlraw[1];
			debugMessageCollection += "--- 4: " + showurl + "\n";
			
            debug(rawshows[i]);
            
			showchannelregexp = /<span class="tv-sendung-info">\(<a href="\/programm\?format=channel&channelId=[^"]*"><b>([^<]*)<\/b>/;
			showchannel = rawshows[i].match(showchannelregexp);
			channel = showchannel[1];
			debugMessageCollection += "--- 5: " + channel + "\n";

			showdescregexp = /<span class="tv-sendung-info">\(<a href="\/programm\?format=channel&channelId=[^"]*"><b>[^<]*<\/b><\/a>\)\s*(-?\d*?\/)?(-?\d+ Min\.\s*?(bis [0-9.]*)?)\s*(Showview [0-9\-]*<br\/?>)?\s*(.*?)\s*(<img[^>]+>\s*)*\s*<\/span>/;
			showdescraw = rawshows[i].match(showdescregexp);
			
			showlength = "";
			showlength = (undefined != showdescraw[2] ? showdescraw[2] : "30 Min. (geraten)");
			var parsedLength = parseInt(showlength);
			if (parsedLength < 0) // oh, this has happened before...
			{
				alert("Weird show length. Assuming 30 minutes.");
				showlength = "30 Min. (geraten)";
			}
			if (parsedLength > 1440) // oh, this has happened before, too... (1440 equals 24 hours)
			{
				alert("Weird show length. Assuming 24 hours.");
				showlength = "1440 Min. (geraten)";
			}
			if(!showdescraw[3] && starttime) {		// we have no end-time: Calculate
				var startTimeParts = starttime.split('.');
				var calcEndTime = new Date();
				calcEndTime.setHours(startTimeParts[0]);
				calcEndTime.setMinutes(startTimeParts[1]);
				calcEndTime.setTime(calcEndTime.getTime() + (1000 * 60 * parsedLength));
				var hr = calcEndTime.getHours() % 24;		hr = (hr < 10) ? '0' + hr : hr;
				var mn = calcEndTime.getMinutes();			mn = (mn < 10) ? '0' + mn : mn;
				showlength += " bis " + hr + ":" + mn;
			}
			debugMessageCollection += "--- 6: " + showlength + "\n";
			showdesc = "";
			
			if((showdescraw.length > 3) && (undefined != showdescraw[5])) {
				showdesc += showdescraw[5].replace(/(<br *\/?>)*\s*/g, '');
			}
			debugMessageCollection += "--- 7: " + showdesc + "\n";
			
			var thisHour = Math.abs(starttime.split(".")[0]);
			if (thisHour < lastEncounteredHour)
			{
				debug("midnight reached");
				inSecondHalf = true;
				if (untilMidnight)
				{
					doBreak = true;
					break;
				}
			}
			lastEncounteredHour = thisHour;
			
			if ((untilMidnight && !inSecondHalf) || (!untilMidnight && inSecondHalf))
			{
				var thisshow = new Object();
				
				thisshow["title"] = showname;
				thisshow["length"] = showlength;
				if ((undefined != showdesc) && ("" != showdesc)) thisshow["description"] = showdesc;
				if ((undefined != showurl) && ("" != showurl)) thisshow["url"] = showurl;
				if ((undefined != iconurl) && ("" != iconurl)) thisshow["icon"] = iconurl;
				
				// get a real timestamp for the startdate
				thisshowhour = Math.abs((starttime.split("."))[0]);
				
				var date = new Date();
				date.setTime(date.getTime() + (listingday * 86400000));
				date.setHours(thisshowhour);
				date.setMinutes(Math.abs((starttime.split("."))[1]));
				date.setSeconds(0);
				thisshow["timestamp"] = date;
				
				// calculate an endstamp
				thisshow["endtime"] = new Date();
				if("" != showlength) {
					var durparts = showlength.split(" ");
					thisshow["durationInMin"] = Math.abs(durparts[0]);
					thisshow["endtime"].setTime(date.getTime() + (durparts[0] * 60 * 1000));
				}
				else {
					alert("Got no duration for " + thisshow["title"] + " on " + channel + ", assuming 30 Minutes");
					thisshow["durationInMin"] = 30;
					thisshow["endtime"].setTime(Math.abs(date.getTime() + 1800000));		// to be on the safe side and at least have an endstamp (30min after start)
				}
				debugMessageCollection += "--- 8: " + showname + "\n";
				debugMessageCollection += "--- 9: " + starttime + "\n";
							
				if (!doBreak) newShows[starttime] = thisshow;
			}
		}	
	}
	
	// error caught
	catch(exc)
	{	
		parseErrorOccurred = true;
		stopCacheIndicator();
		
		document.getElementById('content').style.top = '0px';
	 	document.getElementById("previousShows").style.opacity = 0.4;
		document.getElementById("nextShows").style.opacity = 0.4;
		
		debug(debugMessageCollection ? debugMessageCollection : "No debug message collection available");
		alert("Fehler beim Parsen des Programms (Tag " + listingday + ": " + cachingDate.toLocaleString() + ", Source " + rawsource.length + " Zeichen): " + exc);
		showDialog("Beim Analysieren der Daten von TVToday ist ein Fehler aufgetreten.<br /><br />Dies kann unterschiedliche Ursachen haben, die wahrscheinlichste ist da&szlig; TVToday das Format seiner Seiten ver&auml;ndert hat.<br />In diesem Fall k&ouml;nnen Sie nur auf ein Update seitens der Entwickler warten.", "Ignorieren", blendDialogOut, "Webseite &ouml;ffnen", gotoWebsite);
		return newShows;
	}
	hasMoreLink = (rawsource.indexOf("<a href=\"javascript:nextPage();\">") > -1);
	
	debug("num shows parsed "+(keysFromHash(newShows)).length);

	return newShows;
}
