//
// FernsehWidget
// Von Pascal Pfiffner und Sebastian Krauß
//

var req;
var previous; // url für die vorigen sendungen
var further; // url für die nächsten sendungen
var currentlyloading;
var progressAnimationTimer;
var currentID;
var currentShowDescURL;
var isSearchResult;
var lastSearchDate;
var isQuickAccessSearch;
var quickAccessDay;
var quickAccessHour;
var elapsedTimeCanvasses;
var eyetvEnabled;
var eyetvChannels = new Array();
var eyetvIsCurrentlyPlaying;
var previousChosenShortcut;

// array with the channels
var channels_main = new Object();
var channels_two = new Object();

// variables needed to verify the date
var numNextPages;
var previousNumPages;
var firstShowStamp;
var previousShowTime;
var daysPastMidnight;

// Which show was previously shown?
var previousShowObject;
var previousShowClass;

var furtherArray;
var previousArray;
var furtherBTArray;
var previousBTArray;

var waitingForChannels;
var waitingForTime;
var waitingForDay;
var waitingForDisplayMode;

var numEntriesJetztUndGleich;

var newVersionRequest;
var newVersionUrl;

var showErrorWhenGettingShows;
var errorOccurredWhenGettingShows;

var alreadySearchedInCache;
var numDaysToPrecache;

var debugMode = false;
var showFilters;
var wasBTRequest = false;
var btSupport;
var btDeviceConnnected;

var refreshBlocked = false;
var releaseRefreshBlock = true;
var didDoCache = false;

var MAX_POSSIBLE_DAYS_CACHE = 6;


function loaded()
{
	startCacheIndicator();
	setCacheIndicatorText("Starten...");
	
	isCurrentlyLoadingListing = false;
	
	forwardCacheAborted = false;
	alreadySearchedInCache = false;
	showErrorWhenGettingShows = true;
	currentID = 0;
	currentlyloading = false;
	isSearchResult = false;
	numNextPages = 0;
	previousNumPages = 0;
	elapsedTimeCanvasses = new Array();
	
	// Safari Beta 3 fix (history of searchfields does not work). Enable search history for Safari 2.x though
	if(navigator && navigator.userAgent) {
		var reg = /AppleWebKit\/([\d\.]+)/;
		reg.exec(navigator.userAgent);
		var webkit_version = RegExp.$1;
		
		if("419.1" != webkit_version) {
			//alert("old webkit: " + webkit_version);
			getObj('searchInput').setAttribute('results', 10);
		}
	}
	
	// resize the widget
	if(window.widget) {
		var winX = widget.preferenceForKey("windowX");
		var winY = widget.preferenceForKey("windowY");
		if((undefined != winX) && (undefined != winY))
			window.resizeTo(winX, winY);
	}
	
	// set the mainFont size and the version
	setMainFontSize();
	getCurrentVersion();
	
	scrollerInit(getObj("myScrollBar"), getObj("myScrollTrack"), getObj("myScrollThumb"));
	
	// apply new WebKit-features if we have a new WebKit-version
	if (has1043Features())
	{
		var shortcutSelector = getObj("shortcuts");
		var shortcutOptions = shortcutSelector.options;
		for(var s = 0; s < shortcutOptions.length; s++) {
			if('' == shortcutOptions[s].value) {
				shortcutSelector.insertBefore(document.createElement("hr"), shortcutOptions[s]);
				shortcutSelector.removeChild(shortcutOptions[s]);
			}
		}

		var selector = getObj("uhrzeit");
		var options = selector.options;
		for(var s = 0; s < options.length; s++) {
			if('' == options[s].value) {
				selector.insertBefore(document.createElement("hr"), options[s]);
				selector.removeChild(options[s]);
			}
		}
		
		selector = getObj("defaultChannelGroup");
		options = selector.options;
		for(var s = 0; s < options.length; s++) {
			if('' == options[s].innerHTML) {
				selector.insertBefore(document.createElement("hr"), options[s]);
				selector.removeChild(options[s]);
			}
		}
	}
	

	// create buttons
	createGenericButton(getObj("eyetv_start_button"), "Sender zuweisen", startEyeTVAndSwitchToPrefs, 120);
	createGenericButton(getObj("done"), "Fertig", savePrefs);
	createGenericButton(getObj("clear_cache_button"), "Cache löschen", clearCache);
	
	createGenericButton(getObj("filter_button_cancel"), "Abbrechen", hideNewFilterSheet);
	createGenericButton(getObj("filter_button_set"), "Setzen", setNewFilter);
	
	// days to precache
	var opt = getObj("numDaysToPrecache");
	var optvalue = widget.preferenceForKey("numDaysToPrecache");
	if(undefined != optvalue)
	{
		/*if (parseInt(optvalue) > MAX_POSSIBLE_DAYS_CACHE)
		{
			optvalue = MAX_POSSIBLE_DAYS_CACHE;
			widget.setPreferenceForKey(""+MAX_POSSIBLE_DAYS_CACHE, "numDaysToPrecache");
			FernsehPlugin.emptyCache();
		}*/
		selectValue(opt, optvalue);
	}
	numDaysToPrecache = getNumDaysToPrecache();
	//alert("numDaysToPrecache " + numDaysToPrecache);
	
	/*****************
	 * setup Prefs:
	 *****************/
	
	// main Font Size
	var opt = getObj("mainFontSize");
	var optvalue = widget.preferenceForKey("mainFontSize");
	if (undefined != optvalue) selectValue(opt, optvalue);
	
	// Movie Database
	var opt = getObj("movieDatabase");
	var optvalue = widget.preferenceForKey("movieDatabase");
	if (undefined != optvalue) selectValue(opt, optvalue);
	
	// default day to show
	var opt = getObj("ztag");
	var optvalue = widget.preferenceForKey("day");
	if (undefined != optvalue) selectValue(opt, optvalue);
	
	// default time to show
	opt = getObj("uhrzeit");
	optvalue = widget.preferenceForKey("hour");
	if (undefined != optvalue) selectValue(opt, optvalue);
	
	// default channelGroup to show
	var opt = getObj("defaultChannelGroup");
	var optvalue = widget.preferenceForKey("defaultChannelGroup");
	if(undefined != optvalue)
		selectValue(opt, optvalue);
	
	// number of channels to show
	opt = getObj("numEntriesPerPage");
	optvalue = widget.preferenceForKey("numEntriesPerPage");
	if(undefined != optvalue)
		selectValue(opt, ""+optvalue);
	
	optvalue = widget.preferenceForKey("showShortDesc");
	if ((optvalue != undefined) && (optvalue == "1")) getObj("kurzInfoStandard").checked = true;
	
	var lastUsedVersion = widget.preferenceForKey("LastUsedVersion");
	if (undefined != lastUsedVersion)
	{
		// Channel Grouping
		channels_main = getChannelGroup("channels_main");
		channels_two = getChannelGroup("channels_two");
	}
	
	if ("1" == widget.preferenceForKey("debugMode")) debugMode = true;
	if (debugMode) widget.system("/usr/bin/osascript -e 'tell application \"Console\" to activate'", null);

	
	// make sure at least channels_main is filled with a couple of default values for the first start
	var numAssignedMain = 0;
	for (var key in channels_main) { numAssignedMain++; }
	
	// change from 1.8.2 to 1.8.3, the groups have to be re-populated due to name changes
	widget.setPreferenceForKey(getComparableVersionnumber(getCurrentVersion()), "LastUsedVersion");
	
	if ((0 == numAssignedMain) || (undefined == lastUsedVersion))
	{
		var parentDiv = 'channels_main';
		
		addChannelToGroup("ARD", "ARD", parentDiv);
		addChannelToGroup("ZDF", "ZDF", parentDiv);
		addChannelToGroup("SAT1", "SAT.1", parentDiv);
		addChannelToGroup("RTL", "RTL", parentDiv);
		addChannelToGroup("PRO7", "PRO 7", parentDiv);
		addChannelToGroup("K1", "Kabel 1", parentDiv);
		addChannelToGroup("VOX", "VOX", parentDiv);

		channels_main["ARD"] = "ARD";
		channels_main["ZDF"] = "ZDF";
		channels_main["SAT1"] = "SAT.1";
		channels_main["RTL"] = "RTL";
		channels_main["PRO7"] = "PRO 7";
		channels_main["K1"] = "Kabel 1";
		channels_main["VOX"] = "VOX";

		if ("CH" == currentLocale())
		{
			addChannelToGroup("SF1", "SF1", parentDiv);
			addChannelToGroup("SF2", "SF2", parentDiv);
			addChannelToGroup("ORF1", "ORF 1", parentDiv);
			channels_main["SF1"] = "SF1";
			channels_main["SF2"] = "SF2";
			channels_main["ORF1"] = "ORF 1";
		} else if ("AT" == currentLocale()) {
			addChannelToGroup("ORF1", "ORF 1", parentDiv);
			addChannelToGroup("ORF2", "ORF 2", parentDiv);
			channels_main["ORF1"] = "ORF 1";
			channels_main["ORF2"] = "ORF 2";
		} else {
			addChannelToGroup("N3", "NDR", parentDiv);
			channels_main["N3"] = "NDR";
		}
	}
	
	// Filters
	if (undefined != widget.preferenceForKey("show_filters"))
	{
		showFilters = Deserialize(widget.preferenceForKey("show_filters"));
	} else showFilters = new Array();
	
	for(var p = 0; p < showFilters.length; p++) {
		showFilter(p);
		debug("filter " + showFilters[p]["string"]);
	}
	
	
	// Growl
	optvalue = widget.preferenceForKey("growlSupport");
	if ((optvalue != undefined) && (optvalue == "1") && FernsehPlugin && (FernsehPlugin.canUseGrowlNotification())) 
	{
		getObj("growlSupport").checked = true;
		// no reason to worry, even if set to true, the plugin
		// ignores this if Growl is not installed and/or running
		FernsehPlugin.setUsesGrowlNotification(true);	
	}
	if (!(FernsehPlugin && FernsehPlugin.canUseGrowlNotification())) {
		getObj("growlSupport").disabled = true;
		getObj("growlSupport").checked = false;
	}
	
	// Alerts
	opt = getObj("erinnerung");
	optvalue = widget.preferenceForKey("reminder");
	if (undefined != optvalue)
	{
		selectValue(opt, optvalue);
		if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(optvalue);
		// 120 is the default in the plugin and in the gui.
		// no need to explicitly set it.
	}
	
	// EyeTV Channels
	if (undefined != lastUsedVersion) eyetvChannels = getEyeTVChannelAssigns();
	
	// populate sounds
	var alarmSound = FernsehPlugin.timerSound();
	var selector = getObj('alarmton');
	var sounds = FernsehPlugin.validSounds();
	var currentLibrary = 0;
	for(i = 0; i < sounds.length; i++) {
		var components = sounds[i].split("/");
		
		// new library; add separator
		var separator;
		
		if(currentLibrary != components[1]) {
			if(has1043Features())
				separator = document.createElement("hr");
			else {
				separator = document.createElement("option");
				separator.value = '';
				separator.innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
			}
			selector.appendChild(separator);
		}
		
		// add new sound-option
		soundname = components[components.length - 1];
		soundname = soundname.substring(0, soundname.indexOf(".", soundname.length - 6));
		
		var newoption = document.createElement("option");
		newoption.value = sounds[i];
		newoption.innerHTML = (soundname.length > 0) ? soundname : "Systemsound";
		newoption.selected = (sounds[i] == alarmSound);
		selector.appendChild(newoption);
		
		currentLibrary = components[1];
	}
	
	// elgato EyeTV support
	eyetvEnabled = widget.preferenceForKey("eyetvEnabled");
	useFormac = widget.preferenceForKey("formacEnabled");
	
	if ((eyetvEnabled == 1 ) && (useFormac == 1)) useFormac = 0;
	
	if((undefined != eyetvEnabled) && (eyetvEnabled == 1))
	{
		weUseEyeTV();
		getObj("eyetvSupport").checked = true;
		if (FernsehPlugin) appName = FernsehPlugin.appNameForEyeTV();
	}
	if((undefined != useFormac) && (useFormac == 1))
	{
		weUseFormac();
		getObj("formacSupport").checked = true;
		if (FernsehPlugin) appName = FernsehPlugin.appNameForFormac();
	}
		
	if (FernsehPlugin && !FernsehPlugin.canUseEyeTV())
	{
		getObj("eyetvSupport").disabled = true;
	}
	if (FernsehPlugin && !FernsehPlugin.canUseFormac())
	{
		getObj("formacSupport").disabled = true;
	}
	
	// select necessary layer
	switchToPrefSection("pref_form");
	
	if(window.widget)
	{
		widget.onshow = onShow;
		widget.onhide = onHide;
		widget.onremove = cleanUp;
	}
	
	previousChosenShortcut = "-";
	numEntriesJetztUndGleich = 3;
	if (undefined != widget.preferenceForKey("numGroupEntries")) numEntriesJetztUndGleich = Math.abs(widget.preferenceForKey("numGroupEntries"));
	
	cacheBase = FernsehPlugin.cachePath() + "/";
	FernsehPlugin.cleanupCache();
		
	stopCacheIndicator();
	
	// DEBUG
	//alert("location: " + document.location);
	// END DEBUG
	
	// DISPLAY SHOWS FROM HERE ON
	
	setTimeout("updateTVListing();", 1);
	setTimeout("checkForNewVersion();", 2000);

	if (!debugMode) setTimeout("startCacheIndicator();",3950);
	if (!debugMode) setTimeout("setCacheIndicatorText(\"Filter prüfen...\");",3950);
	if (!debugMode) setTimeout("updateFilterBadge();", 4000);
	
	btDeviceConnnected = "0";
	btSupport ="0";
	var bttemp = widget.preferenceForKey("BluetoothSupport");
	if (undefined != bttemp) btSupport = bttemp;
	if (!FernsehPlugin.canUseBluetooth() && "1" == btSupport) btSupport = "0";
	
	if ("1" == btSupport) FernsehPlugin.setBTEnabled(true);
}	

function checkForNewVersion()
{
	var requesturl = (debugMode ? "http://widgetschmie.de/versions/fernsehenDebug" : "http://www.widgetschmie.de/widgets/Fernsehen/latest.widgetinfo");
	
	newVersionRequest = new XMLHttpRequest;
	newVersionRequest.onreadystatechange = checkForNewVersionDone;
	newVersionRequest.open("GET", requesturl, true);
	newVersionRequest.setRequestHeader("Cache-Control", "no-cache");
	newVersionRequest.send(null);
}

function checkForNewVersionDone()
{
	if ((newVersionRequest.readyState == 4) && (newVersionRequest.status >= 200) && (newVersionRequest.status < 400))
	{
		// get latest version
		var answer = newVersionRequest.responseText;
		var components = answer.split("\n");
		
		var newVersion = getComparableVersionnumber(components[0]);
		newVersionUrl = components[1];
		var newDesc = components[2];
		
		// get current version (from local Info.plist file)
		var thisVersion = getComparableVersionnumber(getCurrentVersion());
		
		// compare versions
		// we support version-numbering with up to 3 dots, e.g. 1.8.1.4
		// the last 2 steads support up to --6-- numbers, first 2 up to --3--
		// 1.8.1.4 becomes 1 008 000001 000004
		if(thisVersion >= newVersion) {
			//alert("Version check performed. No new version available.");
			return;
		}
		
		showDialog("Eine neue Version von &#8222;Fernsehen&#8221; ist verfügbar.<br>Ihre Version: " + getBeautifulVersionnumber(thisVersion) + " &mdash; Neue Version: " + getBeautifulVersionnumber(newVersion) + "<br /><br />" + newDesc + "<br><br>Möchten Sie die neue Version jetzt laden?", "Ignorieren", blendDialogOut, "Laden", getNewVersion);
	}
}

function getNewVersion()
{
	blendDialogOut();
	widget.openURL(newVersionUrl);	
}

function forwardCache()
{
	//if (debugMode) return;
	if (networkErrorOccurred) return;
	
	var date = new Date();
	if (date.getHours() < 1) return;
	if (date.getHours() > 22) return;

	var channels = keysFromHash(channels_main).concat(keysFromHash(channels_two));
	
	var z;
	for (z = 0; z < numDaysToPrecache+1; z++)
	{
		if (!cachedDataAvailable(channels, z))
		{
			didDoCache = true;
			backgroundCachedData(channels, z, forwardCache);
			return;
		}
	}
	if (didDoCache) updateFilterBadge();
	didDoCache = false;
}

function getListingDay()
{
	var opt = getObj("ztag");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getListingTime()
{
	var opt = getObj("uhrzeit");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getDefaultChannelGroup() {
	var opt = getObj("defaultChannelGroup");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getNumberOfEntriesToDisplay() {
	var opt = getObj("numEntriesPerPage");
	var ret = Math.abs(opt.options[opt.selectedIndex].value);
	return (ret > 50 || ret < 1) ? 30 : ret;
}

function getChannelGroup(group) {
	var parent = getObj(group);
	if(!parent)
		return;
	
	var temphash = new Object();
	if(window.widget && widget.preferenceForKey(group)) {
		var grouparr = widget.preferenceForKey(group).split("|");
		var properties;
		for(i = 0; i < grouparr.length-1; i++) {
			properties = grouparr[i].split(":");
			if(properties[0].length > 0) {
				temphash[properties[0]] = properties[1];
				showChannelInGroup(properties[0], properties[1], group);
			}
			//alert("channel " + properties[0] + ":" + properties[1]);
		}
	}
	return temphash;
}

function getNumDaysToPrecache() {
	var opt = getObj("numDaysToPrecache");
	var ret = Math.abs(opt.options[opt.selectedIndex].value);
	return ret;
}

function getEyeTVChannelAssigns() {
	if(window.widget)
		optvalue = widget.preferenceForKey("eyetvChannels");
	
	var tmpChannels;
	var curChannel;
	var tmpArray;
	var channels = new Object();
	
	if(undefined != optvalue) {
		tmpChannels = optvalue.split("////");
		tmpChannels.pop();
		
		for(i = 0; i < tmpChannels.length; i++) {
			curChannel = tmpChannels[i];
			tmpArray = curChannel.split(">>>>");
			channels[tmpArray[0]] = tmpArray[1];
		}
	}
	
	return channels;
}

// dummy function for pre-caching data
// don't delete!
function noop()
{
}

function getShowsFromArray(array)
{
	var channels = array[0];
	var listingday = parseInt(array[1]);
	var numEntries = array[2];
	var startindex = array[3];
	
	debug("getshowsfromarray listingday "+listingday);
	
	var showsErrorCaching = new Array();
	
	var allShows = new Array();
	var keyedShows = new Object();

	for (var channel in channels)
	{
		if ((channel == undefined) || (channel == null)) continue;

		var shows = cachedData(channel, listingday);

		if(!shows)
		{
			showsErrorCaching.push(channel);
			errorOccurredWhenGettingShows = true;
			continue;
		} else keyedShows[channel] = shows;

		for (var thisshow in shows)
		{
			allShows.push(thisshow + " " + channel);
		}
	}
		
	// sortieren.
	allShows.sort();
	
	var i = startindex;
	if (0 > i) i = allShows.length + i;
	
	var max = i + numEntries;
	var nextDay = 0;
	if (max >= allShows.length)
	{
		nextDay = max - allShows.length;
		max = allShows.length;
	}
	
	var retValue = new Array();
	for (var j = i; j < max; j++)
	{
		var thisentry = allShows[j];
		var components = thisentry.split(" ");
		var time = components[0];
		components.shift();
		var channel = components.join(" ");
		var temp = keyedShows[channel];
		var thisshow = temp[time];
		thisshow["time"] = time;
		thisshow["listingday"] = "" + listingday;
		thisshow["channel"] = channel;
		retValue.push(thisshow);
	}
	
	var furtherstartidx = max;
	var furtherlistingday = listingday;
	
	var nextDayOK = true;
	
	if (furtherstartidx >= allShows.length)
	{
		furtherstartidx -= allShows.length;
		furtherlistingday = parseInt(listingday) + 1;
		if (8 == listingday) furtherlistingday = 0;
		if (8 == furtherlistingday) nextDayOK = false;
	}
	var previousstartidx = i - numEntries;
	var previouslistingday = listingday;
	if (0 > previousstartidx)
	{
		// previousstartidx MUST be left negative. getShowsFromArray deals with that.
		previouslistingday--;
	}

	if (-1 == previouslistingday) previouslistingday = 8;
	furtherArray = new Array (channels, furtherlistingday, getNumberOfEntriesToDisplay(), furtherstartidx);
	if (!nextDayOK) furtherArray = null;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = null;
	
	if (nextDay > 0)
	{
		if (listingday == 7) return retValue;
		if (listingday == 8) listingday = 0;
		else listingday += 1;
	
		var othershows = getShows(channels, "00.00", listingday, nextDay);
		for (var i = 0; i < othershows.length; i++)
		{
			retValue.push(othershows[i]);
		}
	}
	if (-1 == previouslistingday) previouslistingday = 8;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = undefined;
		
	return retValue;
}

function channelNameFromInternalName(channel)
{
	var temp = channels_main[channel];
	if (temp != undefined) return temp;
	temp = channels_two[channel];
	if (temp != undefined) return temp;
	return channel;
}

function changeNumGroupEntries(amount)
{
	var clickedHeader = event.currentTarget.parentNode.parentNode.id;
	var clickOffset = event.y - 50;		// Hardcode the amount of the Top-Margin
	
	var amt = parseInt(amount);
	numEntriesJetztUndGleich += amt;
	widget.setPreferenceForKey(numEntriesJetztUndGleich, "numGroupEntries");
	takePreparedData();
	
	// scroll to position
	var topoffset = getObj(clickedHeader).offsetTop;
	getObj("content").style.top = ((topoffset - clickOffset) * -1) + "px";
	calculateAndShowThumb(getObj("content"));
}

function prepareShowsAndDisplay(channels, starttime, listingday, displayMode)
{
	var numChannels = 0;
	for (var channel in channels)
	{
		numChannels++;
	}
	if (0 == numChannels)
	{
		switchToPrefSection("channels_form");
		showDialog("Für diese Gruppe sind keine Sender definiert", "OK", blendDialogOut, "Definieren", showPrefs);
		stopProgressBar(); // just in case, shouldn't be necessary
		return;
	}
	
	waitingForChannels = channels;
	waitingForTime = starttime;
	waitingForDay = listingday;
	waitingForDisplayMode = displayMode;
	if (("jetzt" == starttime) && (((new Date()).getHours() < 5))) waitingForDay = 8;
	
	startProgressBar();
	
	backgroundCachedData(keysFromHash(channels), waitingForDay, takePreparedData);
}

function takePreparedData()
{
	var numToDisplay = getNumberOfEntriesToDisplay();
	//if (wasBTRequest) numToDisplay = (keysFromHash(waitingForChannels)).length;
	if ((undefined == numToDisplay) || (numToDisplay > 50)) numToDisplay = 50;

	if ("grouped" == waitingForDisplayMode)
	{
		var extras = new Object();
		for (var key in waitingForChannels)
		{
			var thisHeader = new Object();
			if (numEntriesJetztUndGleich > 1) thisHeader["minus"] = "changeNumGroupEntries(-1);";
			thisHeader["plus"] = "changeNumGroupEntries(1);";
			thisHeader["divID"] = "groupedSender_"+key;
			extras[key] = thisHeader;
		}
		displayGroupedShows(getGroupedShows(waitingForChannels, waitingForTime, waitingForDay, numEntriesJetztUndGleich), extras);
	} else {
		displayShows(getShows(waitingForChannels, waitingForTime, waitingForDay, numToDisplay));
	}
	stopProgressBar();
}

function showChannelSchedule(timestamp, channel)
{
	var time = new Date();
	time.setTime(timestamp);
	var hour = time.getHours();
	var minute = time.getMinutes();
	var timeStrg =  (hour < 10 ? "0" : "") + hour + "." + (minute < 10 ? "0" : "") + minute;
	
	var now = new Date();
	now.setHours(hour);
	now.setMinutes(minute);
	now.setSeconds(0);
	
	var listingday = Math.round((time.getTime() - now.getTime()) / 86400000);
	
	if (-1 == listingday) listingday = 8;
	
	var extras = new Object();	
	var thisHeader = new Object();
	thisHeader["cross"] = "updateTVListing();";
	extras[channel] = thisHeader;
	
	var channels = new Object();
	channels[channel] = channel;
		
	displayGroupedShows(getGroupedShows(channels, timeStrg, listingday, getNumberOfEntriesToDisplay()), extras);
}

function getGroupedShows(channels, starttime, listingday, numEntries)
{
	showErrorWhenGettingShows = false;
	errorOccurredWhenGettingShows = false;
	var keyedShows = new Object();
	listingday = parseInt(listingday);

	if ("jetztundgleich" == starttime)
	{
		for (var channel in channels)
		{
			var tmp = new Object();
			tmp[channel] = channels[channel];
			keyedShows[channel] = getShows(tmp, "jetzt", 0, numEntries);
		}
	} else {
		for (var channel in channels)
		{
			var tmp = new Object();
			tmp[channel] = channels[channel];
			keyedShows[channel] = getShows(tmp, starttime, listingday, numEntries);
		}
	}
	showErrorWhenGettingShows = true;
	furtherArray = null;
	previousArray = null;
	
	if (errorOccurredWhenGettingShows) showDialog("Daten für einige Sender konnten nicht geladen werden, da keine Verbindung zum Internet besteht oder ein Fehler beim Cachen aufgetreten ist.<br>Die angezeigten Daten sind unvollständig.", "OK", blendDialogOut);
	
	return keyedShows;
}

// gets all desired Show-data from cache
function getShows(channels, starttime, listingday, numEntries)
{
	var allShows = new Array();
	var keyedShows = new Object();
	listingday = parseInt(listingday);
	
	var showsErrorCaching = new Array();

	// all shows from all (desired) channels from one day go into one array
	for (var channel in channels)
	{
		if ((channel == undefined) || (channel == null)) continue;

		var shows = cachedData(channel, listingday);
		
		if(!shows)
		{
			if (showErrorWhenGettingShows) showsErrorCaching.push(channel);
			errorOccurredWhenGettingShows = true;
			continue;
		} else keyedShows[channel] = shows;

		for (var thisshow in shows)
		{
			allShows.push(thisshow + " " + channel);
		}
	}
	
	if(showsErrorCaching.length > 0) {
		if(allShows.length < 1) {
			if (showErrorWhenGettingShows) showError();
			errorOccurredWhenGettingShows = true;
			return new Array();
		}
		else {
			showDialog("Daten für " + showsErrorCaching.length + " Sender konnten nicht geladen werden, da keine Verbindung zum Internet besteht oder ein Fehler beim Cachen aufgetreten ist.<br>Die angezeigten Daten sind unvollständig.", "OK", blendDialogOut);
		}
	}
	
	// sortieren.
	allShows.sort();
	
	var numAllShows = allShows.length;

	var numDeleted = 0;
	var i;
	if ("jetzt" == starttime)
	{
		// find the first show that is running right now
		var now = new Date();
		for (i = 0; i < allShows.length; i++)
		{
			var thisentry = allShows[i];
			var components = thisentry.split(" ");
			var time = components[0];
			components.shift();
			var channel = components.join(" ");
			var temp = keyedShows[channel];
			var thisshow = temp[time];
			
			var thisshowstart = thisshow["timestamp"];
			var thisshowend = thisshow["endtime"];
			
			if ((thisshowstart <= now) && (thisshowend >= now)) break;
			
			// does the channel broadcast 24/7 at all?
			if (0 == i)
			{
				if (thisshowstart > now)
				{
					break;
				}
			}
		}
		
		// get rid of the shows that are over.
		// (they might have started later but are still over)
		for (var j = i; j < allShows.length; j++)
		{
			var components = allShows[j].split(" ");
			var tmpstarttime = components[0];
			components.shift();
			var channel = components.join(" ");
			var temp = keyedShows[channel];
			var thisshow = temp[tmpstarttime];
			
			
			if (now.getTime() > thisshow["endtime"].getTime())
			{
				allShows.splice(j--,1);
				numDeleted++;
			}
		}
	} else {
		var requiredTime = Math.abs(starttime.split(".").join(""));

		for (i = 0; i < allShows.length; i++)
		{
			var showTime = (allShows[i].split(" "))[0];
			var thisTime = Math.abs(showTime.split(".").join(""));
						
			if (thisTime >= requiredTime) {
				break;
			}
		}
	}
	
	var max = i + numEntries;
	var nextDay = 0;
	if (max > allShows.length)
	{
		nextDay = max - allShows.length;
		max = allShows.length;
	}
		
	var retValue = new Array();
	for (var j = i; j < max; j++)
	{
		var thisentry = allShows[j];
		var components = thisentry.split(" ");
		var time = components[0];
		components.shift();
		var channel = components.join(" ");
		var temp = keyedShows[channel];
		var thisshow = temp[time];
		thisshow["time"] = time;
		thisshow["listingday"] = "" + listingday;
		thisshow["channel"] = channel;
		retValue.push(thisshow);
	}
	
	max += numDeleted;
	var furtherstartidx = max;
	var furtherlistingday = listingday;
	
	debug("max " + max);
	debug("furtherstartidx " + furtherstartidx);
	debug("numAllShows " + numAllShows);
	//debug("numAllShows " + numAllShows);
	//debug("numAllShows " + numAllShows);
	
	if (furtherstartidx >= numAllShows)
	{
		furtherstartidx -= numAllShows;
		furtherlistingday = listingday + 1;
		if (8 == listingday) furtherlistingday = 0;
	}
	
	debug("listingday " + listingday);
	debug("furtherlistingday " + furtherlistingday);
	
	var previousstartidx = i - numEntries;
	var previouslistingday = listingday;
	if (0 > previousstartidx)
	{
		// previousstartidx MUST be left negative. getShowsFromArray deals with that.
		// (It couldn't even be dealt with here. The number of shows for the previous day is unknown here.)
		previouslistingday = parseInt(previouslistingday) - 1;
	}

	if (-1 == previouslistingday) previouslistingday = 8;
	furtherArray = new Array (channels, furtherlistingday, getNumberOfEntriesToDisplay(), furtherstartidx);
	if (8 == furtherlistingday) furtherArray = null;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = null;
	
	if (nextDay > 0)
	{
		if (listingday == 7) return retValue;
		if (listingday == 8) listingday = 0;
		else listingday += 1;
		
		var othershows = getShows(channels, ("jetzt" == starttime ? "jetzt" : "00.00"), ""+listingday, nextDay);
		for (var i = 0; i < othershows.length; i++)
		{
			retValue.push(othershows[i]);
		}
	}
	if (-1 == previouslistingday) previouslistingday = 8;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = undefined;
	
	return retValue;
}

// displays shows (expects an array with all shows to display)
function displayShows(shows)
{
	hideHelp();
	// (((undefined != eyetvEnabled) && (eyetvEnabled == 1)) || ((undefined != useFormac) && (useFormac == 1)))
	if ((((undefined != eyetvEnabled) && (eyetvEnabled == 1)) || ((undefined != useFormac) && (useFormac == 1))) && (!isSearchResult)) eyetvIsCurrentlyPlaying = currentStation();
	else eyetvIsCurrentlyPlaying = "";
	
	elapsedTimeCanvasses = new Object();
	if(drawer.current > 0) toggleDrawer();
	purgeParagraphs();
	
	var compDate;
	
	var timeelapseds = new Array();
	
	if(shows.length > 0)
	{
		for(var i = 0; i < shows.length; i++)
		{
			var thisshow = shows[i];
			
			// Set the date at the top
			// Do this for the first show displayed
			// Otherwise, does an "in-between header" have to be displayed?
			if (0 == i)
			{
				var date = shows[0]["timestamp"];
				getObj('showdate').innerText = date.getDate() + "." + (date.getMonth() + 1) + ".";
				compDate = thisshow["timestamp"];
			} else {
				var tmStamp = thisshow["timestamp"];
				if (tmStamp.getDay() != compDate.getDay())
				{
					addDateHeader(tmStamp);
				}
				compDate = tmStamp;
			}
			
			var description = "";
			if (undefined != thisshow["description"]) description = thisshow["description"];
			var url = "";
			if (undefined != thisshow["url"]) url = thisshow["url"];
			var length = "";
			if (undefined != thisshow["length"]) length = thisshow["length"];
			var icon = "";
			if (undefined != thisshow["icon"]) icon = thisshow["icon"];
			timeelapseds.push("" + addParagraph(thisshow["time"], thisshow["channel"], thisshow["title"], description, url, icon, length, thisshow["timestamp"]));
			//alert("" + addParagraph(thisshow["time"], thisshow["channel"], thisshow["title"], description, url, icon, length, thisshow["timestamp"]));
		}
		alternateParagraph = false;
	}
	else {
		noResultFound();
		return;
	}
	
	//set the opacity (turn on/off) the arrows at the bottom
	if (undefined != furtherArray)
	{
		unblurItem("nextShows");
	} else {
		blurItem("nextShows");
	}
	if (undefined != previousArray)
	{
		unblurItem("previousShows");
	} else {
		blurItem("previousShows");
	}

	getObj('content').style.top = '0px';
	calculateAndShowThumb(getObj('content'));

	stopProgressBar();
	
	if (!isCurrentlyLoadingListing) forwardCache();
	
	if (wasBTRequest)
	{
		var separator = "{-----}"
		var result = "" + shows.length + separator;
		
		for (var i = 0; i < shows.length; i++)
		{
			result += deunicodifyLatinUmlauts(shows[i]["title"]) + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			result += channelNameFromInternalName(shows[i]["channel"]) + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			result += shows[i]["time"] + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			var length = "";
			if (undefined != shows[i]["length"]) length = shows[i]["length"] + "\n\n";
			var description = "Keine Beschreibung vorhanden";
			if (undefined != shows[i]["description"]) description = deunicodifyLatinUmlauts(shows[i]["description"]);
			description = description.replace(/<br>/g, "\n");
			result += length + description + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			var etvc = eyetvChannels[shows[i]["channel"]];
			if (undefined == etvc) etvc = " ";
			result += etvc + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			result += timeelapseds[i] + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			/*var date = new Date();
			date.setTime(Math.abs(shows[i]["timestamp"]));
			result += printableDate(date) + separator;*/
			//var date = new Date();
			//date.setTime(Math.abs(shows[i]["timestamp"]));
			result += printableDate(shows[i]["timestamp"]) + separator;
		}
		for (var i = 0; i < shows.length; i++)
		{
			var descurl = shows[i]["url"];
			result += (undefined == descurl ? " " : descurl) + separator;
		}
		//alert(result);
		FernsehPlugin.takeBTShows(result);
		previousBTArray = copyArray(previousArray);
		furtherBTArray = copyArray(furtherArray);
	}
	wasBTRequest = false;
}

function displayGroupedShows(shows, headerExtras)
{
	hideHelp();
	if ((typeof(shows) != "object") || (shows.length < 1))
	{
		switchToPrefSection('channels_form');
		showDialog("Für diese Gruppe sind keine Sender definiert", "OK", blendDialogOut, "Definieren", showPrefs);
		return;
	}
	
	if ((((undefined != eyetvEnabled) && (eyetvEnabled == 1)) || ((undefined != useFormac) && (useFormac == 1))) && (!isSearchResult)) eyetvIsCurrentlyPlaying = currentStation();
	else eyetvIsCurrentlyPlaying = "";
	
	elapsedTimeCanvasses = new Object();
	if(drawer.current > 0) toggleDrawer();
	purgeParagraphs();

	var dateSet = false;
	var compDate;
	
	var shouldAddDateHeaders;
	var numGroups = 0;
	for (var group in shows)
	{
		numGroups++;
	}
	shouldAddDateHeaders = (numGroups == 1);
	
	for (var group in shows)
	{
		var theseShows = shows[group];
		addHeader(channelNameFromInternalName(parseChannelName(group)), headerExtras[group]);
		
		for(var i = 0; i < theseShows.length; i++)
		{
			var thisshow = theseShows[i];

			if (shouldAddDateHeaders)
			{
				if (0 == i)
				{
					compDate = thisshow["timestamp"];
				} else {
					var tmStamp = thisshow["timestamp"];
					if (tmStamp.getDay() != compDate.getDay())
					{
						addDateHeader(tmStamp);
					}
					compDate = tmStamp;
				}
			}
		
			//alert("title: " + thisshow["title"]);
			var description = "";
			if (undefined != thisshow["description"]) description = thisshow["description"];
			var url = "";
			if (undefined != thisshow["url"]) url = thisshow["url"];
			var length = "";
			if (undefined != thisshow["length"]) length = thisshow["length"];
			var icon = "";
			if (undefined != thisshow["icon"]) icon = thisshow["icon"];
			addParagraph(thisshow["time"], thisshow["channel"], thisshow["title"], description, url, icon, length, thisshow["timestamp"]);
			
			// Set the date at the top
			// Do this for the first show displayed
			if ((0 == i) && (false == dateSet));
			{
				if (isSearchResult)
				{
					getObj('showdate').innerText = "";
				} else {
					var date = theseShows[0]["timestamp"];
					getObj('showdate').innerText = date.getDate() + "." + (date.getMonth() + 1) + ".";
				}
				dateSet = true;
			}
		}
		alternateParagraph = false;
	}
	
	//set the opacity (turn on/off) the arrows at the bottom
	if (undefined != furtherArray)
	{
		unblurItem("nextShows");
	} else {
		blurItem("nextShows");
	}
	if (undefined != previousArray)
	{
		unblurItem("previousShows");
	} else {
		blurItem("previousShows");
	}

	getObj('content').style.top = '0px';
	calculateAndShowThumb(getObj('content'));

	stopProgressBar();
}

function showError()
{
	hideDrawer();
	showDialog("Ein Netzwerkfehler ist aufgetreten.<br /><br />Bitte überprüfen Sie die Netzwerkeinstellungen.", "Ignorieren", blendDialogOut, "Netzwerk-Diagnose...", openDiagnosis);
}

function updateTVListing()
{
	if(dialogShown) blendDialogOut();

	startProgressBar();

	isSearchResult = false;
	isQuickAccessSearch = false;

	selectValue(getObj('shortcuts'), "-");

	getObj("searchInput").value="";
	
	var channels;
	var channelstoget = (getDefaultChannelGroup().split("|"))[0];
	if ("main" == channelstoget) channels = channels_main;
	else if ("two" == channelstoget) channels = channels_two;
	else channels = mergeHashes(channels_main, channels_two);
	
	prepareShowsAndDisplay(channels, getListingTime(), getListingDay(), (getDefaultChannelGroup().split("|"))[1]);
}

function gotoWebsite() {
	if(window.widget) { 
		widget.openURL("http://widgetschmie.de/");
	}
}

function toggleShow(showName, time, channel, iconurl, buttonID)
{
	button = getObj(buttonID);

	if (FernsehPlugin.alarmExistsForShow(showName, channel, time)) 
	{
		if (undefined != button) button.setAttribute("src", "Images/AlarmOff.png");
		if (undefined != button) button.setAttribute('title', 'Alarm ist aus');
		FernsehPlugin.removeAlarmForShow(showName, channel, time);
	} else {
		if (undefined != button) button.setAttribute("src", "Images/AlarmOn.png");
		if (undefined != button) button.setAttribute('title', 'Alarm ist an');
		var eyetvchannel = eyetvChannels[channel];
		if (undefined == eyetvchannel) eyetvchannel = "";	
		FernsehPlugin.setAlarmForShow(showName, channel, time, iconurl, eyetvchannel);
	}
}

function toggleRowId(element, button, event)
{
	// toggle ALL descriptions
	if (event.altKey)
	{
		var showAll = element.nextSibling.style.display != 'block';
		
		var elements = getObj("content").childNodes;
		for (i = 0; i < elements.length; i++)
		{
			if(elements[i].getAttribute("class") == "descRow") {
				elements[i].style.display = (showAll ? 'block' : 'none');
				elements[i-1].lastChild.previousSibling.lastChild.src = (showAll ? 'Images/iButtonGrau.png' : 'Images/iButton.png');
			}
		}
	}
	
	// toggle single description
	else {
		var nextelem = element.nextSibling;
		if (nextelem.style && nextelem.style.display == 'block')
		{
			nextelem.style.display = 'none';
			button.src='Images/iButton.png';
		} else {
			nextelem.style.display = 'block';
			button.src='Images/iButtonGrau.png';
		}
	}
	
	calculateAndShowThumb(getObj('content'));
}


function noResultFound() {
	purgeParagraphs();
	stopProgressBar();
	getObj("content").style.top = "0px";
	getObj("content").innerHTML = "<div class=\"notFound\">Keine Sendung gefunden</div>";
	calculateAndShowThumb(getObj("content"));
	getObj('showdate').innerText = "";
}


var alternateParagraph = false;
function addParagraph(i_time, i_channel, i_title, i_desc, i_moreinfo, i_iconurl, i_showlength, i_showTimeStamp)
{
	var parent = getObj('content');
	// main <p>
	
	if ((undefined == i_title) || ("" == i_title)) i_title = "Name der Sendung fehlt";
	
	// DEBUG
	if (debugMode) i_title = ""+i_showTimeStamp;
	
	var paragraph = document.createElement('p');
	paragraph.setAttribute("class", alternateParagraph ? 'mainRow2' : 'mainRow');

	alternateParagraph = !alternateParagraph;
	
	var listingday = isSearchResult ? listingDayFromSearchDate() : getListingDay();
	if (isQuickAccessSearch) listingday = quickAccessDay;
	
	
	// create the alarm-icon (a canvas actually)
	var alarmCanBeSet = ((new Date()).getTime() < i_showTimeStamp.getTime());
	var alarmExists = FernsehPlugin.alarmExistsForShow(i_title, i_channel, i_showTimeStamp.getTime());
	
	var checkbox = document.createElement('img');
	checkbox.setAttribute('class', "reminder");
	
	var canvasid = "-";
	var timeelapsed = " ";
	
	var searchStrings = new Array();
	if (isSearchResult) 
	{
		var temp = new Object();
		//temp["string"] = unicodifyLatinUmlauts(getObj('searchInput').value.toLowerCase());
		temp["string"] = getObj('searchInput').value.toLowerCase();
		temp["mark"] = true;
		temp["title_only"] = false;
		searchStrings.push(temp);
	}
	for (var z = 0; z < showFilters.length; z++)
	{
		//if (!showFilters[z]["mark"]) continue;
		var temp = new Object();
		//temp["string"] = unicodifyLatinUmlauts(showFilters[z]["string"].toLowerCase());
		temp["string"] = showFilters[z]["string"].toLowerCase();
		temp["mark"] = showFilters[z]["mark"];
		temp["title_only"] = showFilters[z]["title_only"];
		searchStrings.push(temp);
	}

	var escapedTitle = i_title.replace(/"/g, "\\\"");
	
	if (!alarmCanBeSet)
	{
		if (i_showlength != "")
		{
			var showlengthparts = i_showlength.split(" ");
			showlength = Math.abs(showlengthparts[0]);
			
			// if no showlength is given, try to calculate			
			if(showlength == 0) {
				if(showlengthparts[3]) {
					var showLastsUntil = showlengthparts[3].split(".");
					showLastsUntil[0] = (showLastsUntil[0] < i_showTimeStamp.getHours()) ? Math.abs(showLastsUntil[0] + 24) : showLastsUntil[0];
					var tempShowLength = ((showLastsUntil[0] * 60) + Math.abs(showLastsUntil[1])) - ((i_showTimeStamp.getHours() * 60) + Math.abs(i_showTimeStamp.getMinutes()));
					tempShowLength = (tempShowLength > 6*60) ? 25 : ((tempShowLength < 1) ? 25 : tempShowLength);	// just to be sure
					
					showlength = Math.floor(tempShowLength / 60) + "." + (tempShowLength % 60);
					i_showlength = tempShowLength + i_showlength;
					//alert(showlength + " " + i_showlength);
				}
				else {
					var title = "Keine Laufzeit";
					checkbox.setAttribute('title', title);
				}
			}
			
			// we have a showlength
			if(showlength != 0) {
				var elapsed = ((new Date()).getTime() - i_showTimeStamp.getTime()) / 60000;
				
				timeelapsed = elapsed/showlength;
				
				var title = minutesAsString(showlength) + " Gesamtlaufzeit\n" + minutesAsString(Math.ceil(timeelapsed*showlength)) + " gelaufen\n" + minutesAsString(showlength-Math.ceil(timeelapsed*showlength)) + " verbleibend";
				if (timeelapsed > 1)
				{
					title = "Sendung vorbei";
					timeelapsed = 1;
				}
	
				checkbox = document.createElement('canvas');
				checkbox.setAttribute('class', "reminder");
				var canvasid = "canvas-" + currentID++;
				checkbox.setAttribute('id', canvasid);
				checkbox.setAttribute('title', title);
				checkbox.setAttribute('width', "12");
				checkbox.setAttribute('height', "12");
				
				elapsedTimeCanvasses[canvasid] = "" + timeelapsed;
				//alert("canvasid "+canvasid+" >> timeelapsed "+timeelapsed);
   			}
		} else {
			 checkbox.setAttribute('src', 'Images/ProgramRunning.png');
			 checkbox.setAttribute('title', 'Sendung läuft');
		}
	} else {
		if (alarmExists)
		{
				checkbox.setAttribute('src', 'Images/AlarmOn.png');
				checkbox.setAttribute('title', 'Alarm ist an');
				timeelapsed = "+";
		} else {
				checkbox.setAttribute('src', 'Images/AlarmOff.png');
				checkbox.setAttribute('title', 'Alarm ist aus');
				timeelapsed = "-";
		}
		var thisButtonID = "buttonID"+currentID++;
		checkbox.setAttribute("id", thisButtonID);
		checkbox.setAttribute("onclick", "toggleShow(\"" + escapedTitle + "\",\"" + i_showTimeStamp.getTime() + "\",\"" + i_channel + "\",\"" + i_iconurl + "\",\"" + thisButtonID + "\");");
		timeelapsed += "toggleShow(\"" + escapedTitle + "\",\"" + i_showTimeStamp.getTime() + "\",\"" + i_channel + "\",\"" + i_iconurl + "\",\"" + thisButtonID + "\");";
	}
	
	// create the eyeTV-Button (only if eyetv is activated)
	if((((undefined != eyetvEnabled) && (eyetvEnabled == 1)) || ((undefined != useFormac) && (useFormac == 1)))) {
		var eyetv_knob = document.createElement('img');
		
		// show is currently running
		if((undefined != eyetvChannels[i_channel]) && !alarmCanBeSet)
		{
			eyetv_knob.setAttribute("id", "playingButton_" + i_channel);
			eyetv_knob.setAttribute("src", (i_channel == eyetvIsCurrentlyPlaying) ? "Images/EyeTV_playing.png" : "Images/EyeTV_readyToPlay.png");
			eyetv_knob.setAttribute("onclick", "switchToRunningShow(\"" + i_channel + "\", this);");
			eyetv_knob.setAttribute('title', 'Sender einschalten');
		} else if (undefined != eyetvChannels[i_channel]) {
			// show can be recorded
			// only EyeTV supports the red tape icon
			var showAlreadyScheduled = ((undefined != eyetvEnabled) && (eyetvEnabled == 1)) && FernsehPlugin.eyeTVTimerExistsForChannel(eyetvChannels[i_channel], ""+i_showTimeStamp.getTime());
			if ((undefined != useFormac) && (useFormac == 1)) showAlreadyScheduled = FernsehPlugin.formacDVBTimerExistsForChannel(eyetvChannels[i_channel], ""+i_showTimeStamp.getTime());

			if (showAlreadyScheduled)
			{
				eyetv_knob.setAttribute("id", "recordButton_" + currentID);
				currentID++;
				
				eyetv_knob.setAttribute("src", "Images/EyeTV_recording.png");
				eyetv_knob.setAttribute("onclick", "deleteRecordTimerForShow(\"" + i_channel + "\", \"" + escapedTitle + "\", \"" + (i_showlength.split(" "))[0] + "\", this, " + i_showTimeStamp.getTime() + ");");
				eyetv_knob.setAttribute('title', 'Sendung wird aufgenommen');
			} else {
				eyetv_knob.setAttribute("src", "Images/EyeTV_readyToRecord.png");
				eyetv_knob.setAttribute("onclick", "setRecordTimerForShow(\"" + i_channel + "\", \"" + escapedTitle + "\", \"" + (i_showlength.split(" "))[0] + "\", this, " + i_showTimeStamp.getTime() + ");");
				eyetv_knob.setAttribute('title', 'Sendung aufnehmen');
			}
		} else {
			// show is not available within eyetv
			eyetv_knob.setAttribute("src", "Images/EyeTV_notAvail.png");
		}
		eyetv_knob.setAttribute("class", "eyetvPlaynow");
		if(timeelapsed >= 1)
			eyetv_knob.setAttribute("style", "opacity:0.0;");		// hide if show is over
	}
	
	// create the time
	var time = document.createElement('span');
	time.setAttribute('class', "time");
	var time_data = document.createTextNode(i_time);
	time.appendChild(time_data);
	if (!isSearchResult)
	{
		var hour = i_showTimeStamp.getHours();
		var minute = i_showTimeStamp.getMinutes();
		var timeStrg =  (hour < 10 ? "0" : "") + hour + "." + (minute < 10 ? "0" : "") + minute;
		
		var now = new Date();
		now.setHours(hour);
		now.setMinutes(minute);
		now.setSeconds(0);
		
		var lday = Math.round((i_showTimeStamp.getTime() - now.getTime()) / 86400000);
		
		if (-1 == lday) lday = 8;
		time.setAttribute("onclick", "prepareShowsAndDisplay(waitingForChannels,\""+timeStrg+"\",\""+lday+"\", \"single\");");
	}
	
	// compose the title; it is located within a div
	var title_pod = document.createElement("div");
	title_pod.setAttribute("class", "titlePod");
	var title_data;
	//var foundMatch = false;
	
	for (var x = 0; x < searchStrings.length; x++)
	{
		// mark the relevant show?
		if (!searchStrings[x]["mark"]) continue;
		var searchString = searchStrings[x]["string"];
		
		var startidx = i_title.toLowerCase().indexOf(searchString);
		/*if (startidx == -1)
		{
			title_data = document.createTextNode(i_title);
		} else {
			title_data = document.createElement('span');
			var elem1 = document.createTextNode(i_title.substr(0,startidx));
			var elem2 = document.createElement('span');
			elem2.setAttribute('class', 'search_result');
			var found = document.createTextNode(i_title.substr(startidx, searchString.length));
			elem2.appendChild(found);
			var reststart = startidx+searchString.length;
			var elem3 = document.createTextNode(i_title.substr(reststart, i_title.length-reststart)); 
			
			title_data.appendChild(elem1);
			title_data.appendChild(elem2);
			title_data.appendChild(elem3);
			
			foundMatch = true;
		}
		if (foundMatch) break;*/
		
		if(startidx >= 0) {
			var reststart = startidx + searchString.length;
			i_title =		i_title.substr(0, startidx)
							+ "<span class=\"search_result\">" + i_title.substr(startidx, searchString.length) + "</span>"
							+ i_title.substr(reststart, i_title.length-reststart);
			break;
		}
	} 
	if (!desc_text) {
		title_data = i_title;
	}
	
	// create channel
	var channel = document.createElement('span');
	channel.setAttribute("class", isSearchResult ? "channel" : "channel channelhover");
	channel.appendChild(document.createTextNode(channelNameFromInternalName(parseChannelName(i_channel))));
	if (!isSearchResult)
	{
		channel.setAttribute("onclick", "showChannelSchedule(\""+i_showTimeStamp.getTime()+"\",\""+i_channel+"\");");
	}
	
	// create the togglebutton if there is more information available
	if(i_desc || i_showlength)
	{
		if (!i_desc) i_desc = "<br>";
		var descs = i_desc.split("<br>");     // !!! NOT <br />
		var showDescOn = getObj("kurzInfoStandard").checked;
		
		for (var x = 0; x < searchStrings.length; x++)
		{
			if (searchStrings[x]["title_only"]) continue;
			if (-1 != i_desc.toLowerCase().indexOf(searchStrings[x]["string"]))
			{
				showDescOn = true;
				break;
			}
		}
		
		var moreinfo_button = document.createElement("img");
		if (showDescOn) moreinfo_button.setAttribute("src", "Images/iButtonGrau.png");
		else moreinfo_button.setAttribute("src", "Images/iButton.png");
		moreinfo_button.setAttribute("class", "toggleshortinfo");
		moreinfo_button.setAttribute("onclick", "toggleRowId(this.parentNode.parentNode, this, event)");
		
		
		// *****************
		// moreinfo
		var desc = document.createElement('p');
		desc.setAttribute("class", "descRow");
		
		
		// ****
		// more info to the left; this panel will float to the left
		if((i_showlength != "") || (undefined != origtitleraw)) {
			var descpanel = document.createElement('div');
			descpanel.setAttribute("class", "descPanel");
			
			// add the showlength
			if (i_showlength != "")
			{
				// if available, add the length of the show below the short desc
				var showlength = document.createElement('span');
				showlength.setAttribute("class", 'showlength');
				showlength.appendChild(document.createTextNode(i_showlength));
				
				descpanel.appendChild(showlength);
			}
			
			
			// add the IMDb-link
			//if (debugMode) alert(i_desc);
			var origtitleregexp = /^\s?\(([^)]*)\) [^;]* \d\d\d\d(\/\d\d)?;.*$/;
			var origtitleraw = i_desc.match(origtitleregexp);
			if (undefined != origtitleraw) 
			{
				var origtitle = origtitleraw[1];
				
				var opt = getObj("movieDatabase");
				var mdb = opt.options[opt.selectedIndex].value;
				
				var imdblogo = document.createElement("img");
				imdblogo.setAttribute("class", "imdb_link");
				
				// IMDb
				if ("imdb" == mdb)
				{
					imdblogo.setAttribute("src", "Images/IMDb_logo.png");
					imdblogo.setAttribute("onclick", "openURL(\"http://www.imdb.com/Find?select=Titles&for=" + origtitle + "&Go.x=15&Go.y=11&Go=Go\")");
					
				}
				
				// German IMDb
				if ("german.imdb" == mdb)
				{
					imdblogo.setAttribute("src", "Images/IMDb_logo.png");
					imdblogo.setAttribute("onclick", "openURL(\"http://german.imdb.com/Find?select=Titles&for=" + origtitle + "&Go.x=15&Go.y=11&Go=Go\")");
				}
				
				// OFDb
				if ("ofdb" == mdb)
				{
					imdblogo.setAttribute("src", "Images/OFDb_logo.png");
					var loc = (""+(document.location)).split("/");
					loc[loc.length-1] = "OFDBSearch.html?Kat=OTitel&SText=";
					loc = loc.join("/");
					imdblogo.setAttribute("onclick", "openURL(\"" + loc + encodeURIComponent(origtitle) + "\")");
				}
				
				if(i_showlength != "")
					descpanel.appendChild(document.createElement('br'));
				descpanel.appendChild(imdblogo);
			} //else debug("kein originaltitel");
		}
		
		
		
		// ****
		// the main moreinfo-text; it resides in a div
		var desc_data = document.createElement("div");
		desc_data.setAttribute("class", "descData");
		var desc_text;
		var thisdesc = descs[0];
		
		if(showDescOn)
			desc.style.display = 'block';
		
		// mark the searchstrings
		//foundMatch = false;
		for (var x = 0; x < searchStrings.length; x++)
		{
			if (!searchStrings[x]["mark"]) continue;
			if (searchStrings[x]["title_only"]) continue;
			
			var searchString = searchStrings[x]["string"];
			
			var startidx = thisdesc.toLowerCase().indexOf(searchString);
			//if (debugMode) alert("desc startidx " + startidx);
			/*if (startidx == -1)
			{
				desc_text = thisdesc;
			}
			else {
				desc_text = document.createElement('span');
				var elem1 = document.createTextNode(thisdesc.substr(0,startidx));
				var elem2 = document.createElement('span');
				elem2.setAttribute('class', 'search_result');
				var found = document.createTextNode(thisdesc.substr(startidx, searchString.length));
				if (debugMode) alert(thisdesc.substr(startidx, searchString.length));
				elem2.appendChild(found);
				var reststart = startidx+searchString.length;
				var elem3 = document.createTextNode(thisdesc.substr(reststart, thisdesc.length-reststart)); 
				
				desc_text.appendChild(elem1);
				desc_text.appendChild(elem2);
				desc_text.appendChild(elem3);
				
				foundMatch = true;
			}*/
			if(startidx >= 0) {
				var reststart = startidx + searchString.length;
				desc_text =		thisdesc.substr(0, startidx)
								+ "<span class=\"search_result\">" + thisdesc.substr(startidx, searchString.length) + "</span>"
								+ thisdesc.substr(reststart, thisdesc.length-reststart);
				break;
			}
		}
		
		if(!desc_text) {
			desc_text = thisdesc;
		}
		
		desc_data.innerHTML = desc_text;
		
		
		// "<br>anschl. Nachrichten"
		for (z = 1; z < descs.length; z++)
		{
			desc_data.appendChild(document.createElement("br"));
			var thisdesc = descs[z];
			var desc_text;
						
			for (var x = 0; x < searchStrings.length; x++)
			{
				if (!searchStrings[x]["mark"]) continue;
				if (searchStrings[x]["title_only"]) continue;
				
				var searchString = searchStrings[x]["string"];
				
				var startidx = thisdesc.toLowerCase().indexOf(searchString);
				//if (debugMode) alert("desc startidx " + startidx);
				/*if (startidx == -1)
				{
					desc_text = document.createTextNode(thisdesc);
				} else {
					desc_text = document.createElement('span');
					var elem1 = document.createTextNode(thisdesc.substr(0,startidx));
					var elem2 = document.createElement('span');
					elem2.setAttribute('class', 'search_result');
					var found = document.createTextNode(thisdesc.substr(startidx, searchString.length));
					if (debugMode) alert(thisdesc.substr(startidx, searchString.length));
					elem2.appendChild(found);
					var reststart = startidx+searchString.length;
					var elem3 = document.createTextNode(thisdesc.substr(reststart, thisdesc.length-reststart)); 
					
					desc_text.appendChild(elem1);
					desc_text.appendChild(elem2);
					desc_text.appendChild(elem3);
					
					foundMatch = true;
				}
				if (foundMatch) break;*/
				if(startidx >= 0) {
					var reststart = startidx + searchString.length;
					desc_text =		thisdesc.substr(0, startidx)
									+ "<span class=\"search_result\">" + thisdesc.substr(startidx, searchString.length) + "</span>"
									+ thisdesc.substr(reststart, thisdesc.length-reststart);
					break;
				}
			}
			
			if (!desc_text) {
				desc_text = thisdesc;
			}

			desc_data.innerHTML = desc_text;
		}
		
		// Genres
		/*var tmpdesc = i_desc;
		var tmpidx = (escape(tmpdesc)).indexOf("%B7");
		if (tmpidx != -1)
		{
			tmpdesc = escape(tmpdesc).replace(/%B7/g, "!!");
			tmpdesc = unescape(tmpdesc);
		}
		var genreregexp = /^\s?(.*?!! )?(\([^)]*\) )?(\S+)( (frei )?nach [^,]*?)?, \S+ \d\d\d\d(.\d\d)?($|;.+| !!)/;
		var genreraw = tmpdesc.match(genreregexp);
		//var genreregexp = /^\s?(\([^)]*\) )?(\S+)( (frei )?nach [^,]*?)?, \S+ \d\d\d\d($|;.+)/;
		//var genreraw = i_desc.match(genreregexp);
		if (undefined != genreraw) 
		{
			var genre = genreraw[3];
			if (debugMode) alert(i_title + " >> " + genre);
			//alert(title_data);
			paragraph.setAttribute('title', genre);
		} else {
			//if (debugMode) alert("kein genre *" + i_desc + "*");
		}*/
		
		
		// ****
		// put it together
		desc.appendChild(descpanel);
		desc.appendChild(desc_data);
	}
	
	
	// *********************************
	// put it together
	
	
	// add the left infopanel
	var lInfoPanel = document.createElement('div');
	lInfoPanel.setAttribute('class', "leftinfopanel");
	lInfoPanel.appendChild(checkbox);
	if(eyetv_knob)
		lInfoPanel.appendChild(eyetv_knob);
	lInfoPanel.appendChild(time);
	paragraph.appendChild(lInfoPanel);
	
	// add the right infopanel
	var rInfoPanel = document.createElement('div');
	rInfoPanel.setAttribute('class', "rightinfopanel");
	rInfoPanel.appendChild(channel);
	rInfoPanel.appendChild(moreinfo_button);
	paragraph.appendChild(rInfoPanel);
	
	// append the title
	if("" != i_moreinfo) {
		var title_link = document.createElement('a');
		var paraID = "infoParagraphID" + currentID++;
		title_link.setAttribute("href", 'javascript:getShowDescription("' + i_moreinfo + '", "' + paraID + '");');
		paragraph.setAttribute('id', paraID);
		title_link.innerHTML = title_data;
		title_pod.appendChild(title_link);
	} else {
		title_pod.innerHTML = title_data;
	}
	paragraph.appendChild(title_pod);
	
	
	// append the description
	parent.appendChild(paragraph);
	if (i_desc || i_showlength) parent.appendChild(desc);
	if (canvasid != "-") drawElapsed(canvasid, timeelapsed);
	
	//if ((" " != timeelapsed) && ("-" != timeelapsed.substring(0,1)) && ("+" != timeelapsed.substring(0,1)))
	if ("string" != typeof(timeelapsed))
	{
		timeelapsed *= 100;
		timeelapsed = ((""+timeelapsed).split("."))[0];
	}
	return timeelapsed;
}

function openURL(url)
{
	refreshBlocked = true;
	widget.openURL(url);
}

function minutesAsString(minutes)
{
	var result = Math.floor(minutes / 60) + ":";
	var remMins = (minutes % 60);
				
	if (remMins < 10) result += "0" + remMins
	else result += remMins;
	
	return result;
}

function drawElapsed(canvasid, timeelapsed)
{
	var canvas = getObj(canvasid);
	var context = canvas.getContext("2d");
	context.clearRect(0,0,12,12);
	context.beginPath();
	context.arc(6, 6, 5.5, 0, 6.2831853072, true);
	context.closePath();
		
	context.lineWidth = 1;
	context.setStrokeColor("#999999");
	context.stroke();
	
	context.setFillColor("#FFFFFF");
	context.fill();

	if (timeelapsed > 0)
	{
		context.beginPath();
		context.moveTo(6, 6);
		// -1.5707963268 ^=  -90 degrees, 12 o'clock on a watch in this case
		context.arc(6, 6, 5.5, -1.5707963268, (timeelapsed * 6.2831853072) - 1.5707963268, false);
		context.closePath();
		context.setFillColor("#888888");
		context.fill();
	}
}

// work around a bug in webkit
function redrawElapsed()
{
	for (var canvasid in elapsedTimeCanvasses)
	{
		drawElapsed(canvasid, parseFloat(elapsedTimeCanvasses[canvasid]));
	}
}

function addHeader(headername, headerExtras)
{
	var parent = getObj("content");
	
	// main <p>
	var paragraph = document.createElement("p");
	paragraph.setAttribute("class", "channelRow");
	var headerTitle = document.createTextNode(headername);
	paragraph.appendChild(headerTitle);
	
	if(typeof(headerExtras) == "object")
	{
		var container = document.createElement("div");
		container.setAttribute("class", "extraHeaderUtilities");
		
		for (var key in headerExtras)
		{
			if ("divID" == key)
			{
				paragraph.setAttribute("id", headerExtras[key]);
				continue;
			}
			var extra = document.createElement("img");
			var divID = "extra" + currentID++;
			container.setAttribute("id", divID);
			extra.setAttribute("src", "Images/" + key + ".png");
			extra.setAttribute("onmousedown", "blurItem(this)");
			extra.setAttribute("onmouseout", "unblurItem(this)");
			extra.setAttribute("onclick", headerExtras[key]);
			extra.setAttribute("class", "extraHeaderItem");
			container.appendChild(extra);
		}
		
		paragraph.appendChild(container);
	}

	parent.appendChild(paragraph);
}

function addDateHeader(date)
{
	var datestring = printableDate(date);
	var parent = getObj("content");
	
	// main <p>
	var paragraph = document.createElement("p");
	paragraph.setAttribute("class", "dateRow");
	var headerTitle = document.createTextNode(datestring);
	paragraph.appendChild(headerTitle);

	parent.appendChild(paragraph);
}

function purgeParagraphs()
{
	var parent = getObj('content');
	var elements = parent.childNodes;
	var a = elements.length;
	
	for(i = a-1; i >= 0; i--) {
		if(elements[i] != null)
			parent.removeChild(elements[i]);
	}
}

function listingDayFromSearchDate()
{
	var components = lastSearchDate.split(".");
	var showday = Math.abs(components[0]);
	var showmonth = Math.abs(components[1])-1; // months are 1 off, [0..11]
	
	var now = new Date();
	
	var nowDate = new Date(now.getFullYear(), now.getMonth(), now.getDate());
	var showDate = new Date(now.getFullYear(), showmonth, showday);
	
	// next year, search took place end december, result in january
	if (showmonth < now.getMonth()) showDate.setFullYear(now.getFullYear()+1);
	
	var daysbetween = (showDate - nowDate) / 86400000;
	
	return daysbetween;
}

function getShowDescription(requesturl, callingID)
{
	if (currentlyloading) return;
	currentlyloading = true;

	if (undefined != callingID)
	{
		callingobj = getObj(callingID);
		
		if (null != previousShowObject)
		{
			previousShowObject.setAttribute('class', previousShowClass);
		}
		previousShowObject = callingobj;
		previousShowClass = previousShowObject.getAttribute("class");
		callingobj.setAttribute('class', 'highlightrow');
	}
	if (!wasBTRequest)
	{
		getObj('drawercontent').innerHTML = "<div class=\"faded\">Lade Beschreibung...</div>";
		resizeDrawer();
	}
	
	currentShowDescURL = requesturl;

	req = new XMLHttpRequest();
	req.onreadystatechange = parseShowDescription;
	req.open("GET", requesturl, true);
	req.setRequestHeader("Cache-Control", "no-cache");
	req.send(null);
}

function parseShowDescription()
{
	if (req.readyState == 4) currentlyloading = false;
	if ((req.readyState == 4) && (req.status == undefined))
	{
		getObj('drawercontent').innerHTML = "";
		resizeDrawer();

		showError();
		return;
	}
	if (!((req.readyState == 4) && (req.status >= 200) && (req.status < 400))) return;
	
	var show = "";
	try
	{
		rawShow = req.responseText;
		rsource = rawShow.replace(/\s/g, " ");
		
		showregexp = /<td align="left" class="tv-sendung-info">(.*?)\s*?<br\/>/;
		showraw = rsource.match(showregexp);
		show = showraw[1];
		
		// sometimes they link to descriptions, but the description is "xxx".
		// instead of displaying "xxx" as description, say that there is none.
		if (show.length < 6)
		{
			show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>";
			getObj('drawercontent').innerHTML = show;
			resizeDrawer();
			return;
		}
		
		var startsearch = (show.length / 2) + 1;
		var doSearch = true;
		
		while (doSearch)
		{
			var thischar = show.charAt(--startsearch);
			if ((thischar == ' ') || (thischar == '.')) doSearch = false;
			
			if (startsearch == 0) doSearch = false;
		}
		
		show = show.substring(0, startsearch);
		
		if (wasBTRequest)
		{
			FernsehPlugin.takeBTShows("Detail{-----}" + show + "...\n\nMehr bei TVToday{-----}" + currentShowDescURL);
			wasBTRequest = false;
			return;
		}
		
		show += "&nbsp;&hellip;<br /><a href=\"javascript:refreshBlocked=true;widget.openURL('" + currentShowDescURL + "');\">Mehr &#187;</a>";
	} catch (exc) {
		// Happens if there is no description. Honestly.
		show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>"; 
		if (wasBTRequest)
		{
			FernsehPlugin.takeBTShows("Detail{-----}Keine Beschreibung vorhanden");
			wasBTRequest = false;
			return;
		}
	}
	
	getObj('drawercontent').innerHTML = show;
	resizeDrawer();
}

function showPrevious()
{
	blurItem("nextShows");
	blurItem("previousShows");
	if (wasBTRequest)
	{
		if (undefined == previousBTArray)
		{
			FernsehPlugin.takeBTShows("0");
			return;
		}
	}
	else if (undefined == previousArray) return;
	startProgressBar();
	array = (wasBTRequest ? previousBTArray : previousArray);
	var prevListingDay = array[1];
	var channels = keysFromHash(array[0]);
	if (!cachedDataAvailable(channels, prevListingDay))
	{
		backgroundCachedData(channels, prevListingDay, noop);
	}
	displayShows(getShowsFromArray(array));
}

function showNext()
{
	blurItem("nextShows");
	blurItem("previousShows");
	if (wasBTRequest)
	{
		if (undefined == furtherBTArray)
		{
			FernsehPlugin.takeBTShows("0");
			return;
		}
	}
	else if (undefined == furtherArray) return;
	startProgressBar();
	array = (wasBTRequest ? furtherBTArray : furtherArray);
	var nextListingDay = array[1];
	var channels = keysFromHash(array[0]);
	nextListingDay++;
	if (nextListingDay == 9) nextListingDay = 0;
	var channels = keysFromHash(array[0]);
	if (!cachedDataAvailable(channels, nextListingDay))
	{
		backgroundCachedData(channels, nextListingDay, noop);
	}
	displayShows(getShowsFromArray(array));
}

function scrollwheel(event, whatdiv)
{
	if (scrollTrack.style.display == 'none') return;
	delta = window.event.wheelDelta/10;
	// delta > 0 rad nach oben
	// delta < 0 rad nach unten
	
	var newv = (parseInt(whatdiv.style.top.replace(/px/, ''))) + delta;
	newv += 'px';
	whatdiv.style.top = newv;
	calculateAndShowThumb(whatdiv);
}

function reminderIntervalChanged()
{
	var opt = getObj("erinnerung");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(""+optval);
}

function updateFilterBadge()
{
	var numHits = numberOfHitsForFilters();
	var obj = getObj("filtercount");
	
	if (0 == numHits)
	{
		obj.style.display = "none";
	} else {
		obj.style.display = "inline-block";
		obj.innerHTML = numHits;
		obj.style.width = (numHits > 99) ? "26px" : "20px";
		obj.style.backgroundImage = (numHits > 99) ? "url(Images/Badge_3.png)" : "url(Images/Badge.png)";
	}
}

function numberOfHitsForFilters()
{
	if (showFilters.length == 0)
	{
		stopCacheIndicator();
		return 0;
	}
		
	var searchStrings = new Array();
	
	for (var i = 0; i < showFilters.length; i++)
	{
		var temp = new Object();
		//temp["string"] = unicodifyLatinUmlauts(showFilters[i]["string"].toLowerCase());
		temp["string"] = showFilters[i]["string"].toLowerCase();
		temp["title_only"] = showFilters[i]["title_only"];
		temp["channel"] = showFilters[i]["channel"];
		searchStrings.push(temp);
	}
	var allChannels = keysFromHash(channels_main).concat(keysFromHash(channels_two));
	
	var showsFound = 0;
	var result = new Object();
	var allShows = new Object();
	for (var day = 0; day < MAX_POSSIBLE_DAYS_CACHE+1; day++)
	{
		var showsThisDay = new Array();
		for (var chCounter = 0; chCounter < allChannels.length; chCounter++)
		{
			var thisChannel = allChannels[chCounter];
			if (undefined == thisChannel) continue;
			if (null == thisChannel) continue;
			if (!cachedDataAvailable(new Array(thisChannel), day)) continue;
			var shows = cachedData(thisChannel, day);
			var keyedShowsDay = new Object();
			for (var key in shows)
			{
				var thisshow = shows[key];
				var title = thisshow["title"].toLowerCase();
				
				var desc = "";
				if (undefined != thisshow["description"]) desc = thisshow["description"].toLowerCase();
				var matchFound = false;
				for (var i = 0; i < searchStrings.length; i++)
				{
					if ("0" != searchStrings[i]["channel"])
					{
						if (("channels_main" == searchStrings[i]["channel"]) || ("channels_two" == searchStrings[i]["channel"]))
						{
							if (!inArray(thisChannel, (("channels_main" == searchStrings[i]["channel"]) ? keysFromHash(channels_main) : keysFromHash(channels_two)))) continue;
						} else if (thisChannel != searchStrings[i]["channel"]) continue;
					}
					if ((title.indexOf(searchStrings[i]["string"]) != -1) || ((!searchStrings[i]["title_only"]) && (desc.indexOf(searchStrings[i]["string"]) != -1)))
					{
						showsFound++;
						break;
					}
				}
			}
		}
	}
	stopCacheIndicator();
	return showsFound;
}

function showAlarms()
{
	blendDialogOut();
	setTimeout("startProgressBar();",1);
	setTimeout("reallyShowAlarms();",10);
}

function reallyShowAlarms()
{
	isSearchResult = false;
	getObj("searchInput").value="";

	var alarms = FernsehPlugin.timers();
	
	if ((undefined == alarms) || (alarms.length == 0))
	{
		if (wasBTRequest)
		{
			FernsehPlugin.takeBTShows("0");
			wasBTRequest = false;
		}
		alert("undefined alarms!");
		noResultFound();
		return;
	}
	
	var result = new Array();
	var today = new Date();
	today.setHours(0);
	today.setMinutes(0);
	
	for (i = 0; i < alarms.length; i++)
	{
		// loop through the shows
		var comps = alarms[i].split(">>>>");
		var showtime = new Date(comps[0], Math.abs(comps[1])-1, comps[2], comps[3], comps[4], 0);
		debug(showtime);
		var channel = comps[5];
		if (undefined == channel) continue;
		if (null == channel) continue;
		
		var showDay = new Date();
		showDay.setTime(showtime.getTime());
		showDay.setHours(0);
		showDay.setMinutes(0);
	
		var listingday = Math.round((showDay.getTime() - today.getTime()) / 86400000);
		
		// debug(listingday + " >> " + channel);
		
		var listing = cachedData(channel, listingday);
		
		var starttime = comps[3]+"."+comps[4];
		var addShow = listing[starttime];
		if (undefined == addShow) debug("No show found!");
		else {
			addShow["channel"] = channel;
			addShow["time"] = starttime;
			result.push(addShow);
		}
	}
	
	furtherArray = null;
	previousArray = null;
	displayShows(result);
}

function showFiltered()
{
	if (showFilters.length == 0)
	{
		switchToPrefSection("filters_form");
		showDialog("Sie haben noch keine Filter für Sendungen angelegt.<br><br>Möchten Sie jetzt Filter anlegen?", "Ignorieren", blendDialogOut, "Filter anlegen", showPrefs);
		return;
	}

	blurItem("filtercount");
	blendDialogOut();
	setTimeout("startProgressBar();",1);
	setTimeout("reallyShowFiltered();",10);
}

function reallyShowFiltered()
{	
	isSearchResult = false;
	getObj("searchInput").value="";

	var searchStrings = new Array();
	for (var i = 0; i < showFilters.length; i++)
	{
		var temp = new Object();
		//temp["string"] = unicodifyLatinUmlauts(showFilters[i]["string"].toLowerCase());
		temp["string"] = showFilters[i]["string"].toLowerCase();
		temp["title_only"] = showFilters[i]["title_only"];
		temp["channel"] = showFilters[i]["channel"];
		searchStrings.push(temp);
	}

	var allChannels = keysFromHash(channels_main).concat(keysFromHash(channels_two));
	
	var showsFound = 0;
	var result = new Object();
	var allShows = new Object();
	for (var day = 0; day < MAX_POSSIBLE_DAYS_CACHE+1; day++)
	{
		var showsThisDay = new Array();
		for (var chCounter = 0; chCounter < allChannels.length; chCounter++)
		{
			var thisChannel = allChannels[chCounter];
			if ((thisChannel == undefined) || (thisChannel == null)) continue;
			if (!cachedDataAvailable(new Array(thisChannel), day)) continue;
			var shows = cachedData(thisChannel, day);
			var keyedShowsDay = new Object();
			for (var key in shows)
			{
				var thisshow = shows[key];
				var title = thisshow["title"].toLowerCase();
				
				var desc = "";
				if (undefined != thisshow["description"]) desc = thisshow["description"].toLowerCase();
				var matchFound = false;
				for (var i = 0; i < searchStrings.length; i++)
				{
					if ("0" != searchStrings[i]["channel"])
					{
						if (("channels_main" == searchStrings[i]["channel"]) || ("channels_two" == searchStrings[i]["channel"]))
						{
							if (!inArray(thisChannel, (("channels_main" == searchStrings[i]["channel"]) ? keysFromHash(channels_main) : keysFromHash(channels_two)))) continue;
						} else if (thisChannel != searchStrings[i]["channel"]) continue;
					}
					if ((title.indexOf(searchStrings[i]["string"]) != -1) || ((!searchStrings[i]["title_only"]) && (desc.indexOf(searchStrings[i]["string"]) != -1)))
					{
						matchFound = true;
						break;
					}
				}
				
				if (matchFound) 
				{
					showsThisDay.push(key + " " + thisChannel);
					keyedShowsDay[key] = thisshow;
					showsFound++;
				}
			}
			allShows[thisChannel] = keyedShowsDay;
		}
		
		if (showsThisDay.length > 0)
		{
			showsThisDay.sort();
			var sortedShows = new Array();
			
			for (var i = 0; i < showsThisDay.length; i++)
			{
				var thisshow = showsThisDay[i];
				var components = thisshow.split(" ");
				var time = components[0];
				components.shift();
				var channel = components.join(" ");
				var tmp = allShows[channel];
				var foundShow = allShows[channel][time];
				foundShow["channel"] = channel;
				foundShow["time"] = time;
				sortedShows.push(foundShow);
			}
			var date = sortedShows[0]["timestamp"];
			var dateStrg = printableDate(date);
			result[dateStrg] = sortedShows;
		}
	}
	
	var flatResult = new Array();
	for (var key in result)
	{
		var shows = result[key];
		for (var i = 0; i < shows.length; i++)
		{
			flatResult.push(shows[i]);
		}
	}
	
	furtherArray = null;
	previousArray = null;
	//if (showsFound > 0) displayGroupedShows(result, new Object());
	if (showsFound > 0) displayShows(flatResult);
	else 
	{
		if (wasBTRequest)
		{
			FernsehPlugin.takeBTShows("0");
			wasBTRequest = false;
		}
		alert("undefined alarms!");
		noResultFound();
	}
	unblurItem("filtercount");
}

function checkAlarmFilter(shows, channel)
{
	if (undefined == channel)
	{
		alert("undefined channel!");
		return;
	}
	var searchStrings = new Array();
	for (var i = 0; i < showFilters.length; i++)
	{
		var temp = new Object();
		if (showFilters[i]["setAlert"] == false) continue;
		//temp["string"] = unicodifyLatinUmlauts(showFilters[i]["string"].toLowerCase());
		temp["string"] = showFilters[i]["string"].toLowerCase();
		temp["title_only"] = showFilters[i]["title_only"];
		if ("" != showFilters[i]["channel"])
		{
			if (("channels_main" == showFilters[i]["channel"]) || ("channels_two" == showFilters[i]["channel"]))
			{
				if (!inArray(channel, (("channels_main" == showFilters[i]["channel"]) ? keysFromHash(channels_main) : keysFromHash(channels_two)))) continue;
			} else if (channel != showFilters[i]["channel"]) continue;
		}
		// debug("filter alarm channel " + showFilters[i]["channel"] + " title " + showFilters[i]["string"]);
		searchStrings.push(temp);
	}

	for (var key in shows)
	{
		var thisshow = shows[key];
		var title = thisshow["title"].toLowerCase();
		
		var desc = "";
		if (undefined != thisshow["description"]) desc = thisshow["description"].toLowerCase();

		for (var i = 0; i < searchStrings.length; i++)
		{
			if ((title.indexOf(searchStrings[i]["string"]) != -1) || ((!searchStrings[i]["title_only"]) && (desc.indexOf(searchStrings[i]["string"]) != -1)))
			{
				//matchFound = true;
				debug("setting alarm for " + title);
				var eyetvchannel = eyetvChannels[channel];
				if (undefined == eyetvchannel) eyetvchannel = "";	
				FernsehPlugin.setAlarmForShow(thisshow["title"], channel, thisshow["timestamp"].getTime(), thisshow["icon"], eyetvchannel);
				
				break;
			}
		}
	}
}

function searchInCache()
{
	blendDialogOut();
	setTimeout("startProgressBar();", 1);
	setTimeout("doSearchInCache();", 20);
}

function doSearchInCache()
{
	alreadySearchedInCache = true;
	var searchString = getObj('searchInput').value.toLowerCase();
	var allChannels = keysFromHash(channels_main).concat(keysFromHash(channels_two));
	
	var showsFound = 0;
	var result = new Object();
	var allShows = new Object();
	for (var day = 0; day < MAX_POSSIBLE_DAYS_CACHE+1; day++)
	{
		var showsThisDay = new Array();
		for (var chCounter = 0; chCounter < allChannels.length; chCounter++)
		{
			var thisChannel = allChannels[chCounter];
			if ((thisChannel == undefined) || (thisChannel == null)) continue;
			if (!cachedDataAvailable(new Array(thisChannel), day)) continue;
			var shows = cachedData(thisChannel, day);
			var keyedShowsDay = new Object();
			for (var key in shows)
			{
				var thisshow = shows[key];
				var title = thisshow["title"].toLowerCase();
				
				var desc = "";
				if (undefined != thisshow["description"]) desc = thisshow["description"].toLowerCase();
				
				if ((title.indexOf(searchString) != -1) || (desc.indexOf(searchString) != -1)) 
				{
					showsThisDay.push(key + " " + thisChannel);
					keyedShowsDay[key] = thisshow;
					showsFound++;
				}
			}
			allShows[thisChannel] = keyedShowsDay;
		}
		
		if (showsThisDay.length > 0)
		{
			showsThisDay.sort();
			var sortedShows = new Array();
			
			for (var i = 0; i < showsThisDay.length; i++)
			{
				var thisshow = showsThisDay[i];
				var components = thisshow.split(" ");
				var time = components[0];
				components.shift();
				var channel = components.join(" ");
				var tmp = allShows[channel];
				var foundShow = allShows[channel][time];
				foundShow["channel"] = channel;
				foundShow["time"] = time;
				sortedShows.push(foundShow);
			}
			var date = sortedShows[0]["timestamp"];
			var dateStrg = printableDate(date);
			result[dateStrg] = sortedShows;
		}
	}
	furtherArray = null;
	previousArray = null;

	var flatResult = new Array();
	for (var key in result)
	{
		var shows = result[key];
		for (var i = 0; i < shows.length; i++)
		{
			flatResult.push(shows[i]);
		}
	}
	
	furtherArray = null;
	previousArray = null;
	//if (showsFound > 0) displayGroupedShows(result, new Object());
	
	if (wasBTRequest && (showsFound > 50))
	{
		FernsehPlugin.takeBTShows("TooManyResults");
		wasBTRequest = false;
		stopProgressBar();
		return;
	}
	
	if (showsFound > 0) displayShows(flatResult);
	else 
	{
		if (wasBTRequest) FernsehPlugin.takeBTShows("0");
		wasBTRequest = false;
		noResultFound();
	}
}

function searchShow(searchstring)
{
	var waitUntilExpand = false;
	if (!isSearchResult && (searchstring == "")) return;
	if (isCollapsed())
	{
		toggleWidget();
		waitUntilExpand = true;
	}
	
	if ("***debugOn***" == searchstring)
	{
		setDebugMode(true);
		showDialog("Debug-Modus ist AN.", "Klaro", blendDialogOut);
		return;
	}
	if ("***debugOff***" == searchstring)
	{
		setDebugMode(false);
		showDialog("Debug-Modus ist AUS.", "Klaro", blendDialogOut);
		return;
	}
	
	if (searchstring == "")
	{
		if (isSearchResult) updateTVListing();
		return;
	}
	if (debugMode) alert(escape(searchstring));
	lastSearchDate = "";
	isSearchResult = true;
	isQuickAccessSearch = false;
	
	setTimeout("searchInCache();", waitUntilExpand ? expandCollapseTime + 51 : 0);
}

function setDebugMode(flag)
{
	debugMode = flag;
	widget.setPreferenceForKey((flag ? "1" : "0"), "debugMode");
	if (debugMode) widget.system("/usr/bin/osascript -e 'tell application \"Console\" to activate'", null);
}

function showHelp()
{
	blendDialogOut();
	var front = getObj("frontDiv");
	var back = getObj("prefDiv");
	
	if(back.style.display == "block") {
		if(window.widget)
			widget.prepareForTransition("ToFront");
					
		front.style.display = "block";
		back.style.display = "none";
		
		if(window.widget)
			setTimeout("widget.performTransition();", 0);
	}
	
	getObj("helpdiv").style.display = 'block';
	getObj("content").style.display = 'none';
	getObj("searchInput").style.display = 'none';
	getObj("toggledrawer").style.display = 'none';
	getObj("shortcutscover").style.display = 'none';
	getObj("shortcuts").style.display = 'none';
	getObj("pages").style.display = 'none';
	getObj("badges").style.display = 'none';
	
	// create closehelp-button
	var hdiv = document.createElement("a");
	hdiv.setAttribute("id", "closeHelp");
	hdiv.setAttribute("href", "javascript:hideHelp();");
	hdiv.setAttribute("onmousedown", "blurItem(this);");
	hdiv.setAttribute("onmouseout", "unblurItem(this);");
	hdiv.innerHTML = "Hilfe schlie&szlig;en";
	
	refreshBlocked = true;
	releaseRefreshBlock = false;
	
	var ldiv = document.createElement("div");
	ldiv.setAttribute("class", "left");
	var rdiv = document.createElement("div");
	rdiv.setAttribute("class", "right");
	
	hdiv.appendChild(ldiv);
	hdiv.appendChild(rdiv);
	getObj("title").appendChild(hdiv);
	
	calculateAndShowThumb(getObj('helpdiv'));
}

function hideHelp()
{
	if(getObj('helpdiv').style.display != "block")
		return;
	
	refreshBlocked = false;
	releaseRefreshBlock = true;
	
	if(null != previous)
		getObj('previousShows').style.display = 'block';
	if(null != further)
		getObj('nextShows').style.display = 'block';
	(getObj("title")).removeChild(getObj("closeHelp"));
	getObj("toggledrawer").style.display = 'block';
	getObj("searchInput").style.display = 'inline';
	getObj("shortcutscover").style.display = 'block';
	getObj("shortcuts").style.display = 'block';
	getObj("helpdiv").style.display = 'none';
	getObj("pages").style.display = 'block';
	getObj("badges").style.display = 'block';
	
	updateTVListing();

	getObj('content').style.display = 'block';
	calculateAndShowThumb(getObj('content'));
	selectValue(getObj('shortcuts'), previousChosenShortcut);
	redrawElapsed();
}

function shortcutChosen()
{
	var opt = getObj('shortcuts')
	var optval = opt.options[opt.selectedIndex].value;
	
	if (optval == "")
	{
		selectValue(opt, previousChosenShortcut);
		return;
	}

	blurItem("nextShows");
	blurItem("previousShows");

	if (optval == "helpFAQ")
	{
		showHelp();
		return;
	}
	
	previousChosenShortcut = optval;

	if (optval == "-")
	{
		updateTVListing();
		return;
	}
	if (optval == "filtered")
	{
		showFiltered();
		return;
	}
	if (optval == "alarms")
	{
		showAlarms();
		return;
	}
	
	var options = optval.split("/");
	
	isSearchResult = false;
	getObj("searchInput").value="";
	var day = options[0];
	var hour = options[1];
	var channel = options[2];
	
	if ("primetime" == hour)
	{
		// Primetime CH: 20.00
		//          D/A: 20.15
		if ("CH" == currentLocale()) hour = "20.00";
		else hour = "20.15";
	}
	
	isQuickAccessSearch = true;
	quickAccessDay = day;
	quickAccessHour = hour;
	var displaymode = options[3];
	
	var channels;
	if ("main" == channel) channels = channels_main;
	else if ("two" == channel) channels = channels_two;
	else channels = mergeHashes(channels_main, channels_two);
	
	prepareShowsAndDisplay(channels, quickAccessHour, quickAccessDay, displaymode);
}

function timerSoundChanged()
{
	var opt = getObj("alarmton");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setTimerSound(optval);
	
	// default alert-sound chosen; play it
	if(!optval) {
		FernsehPlugin.beep();
		return;
	}
	
	// play the chosen alarm-sound
	if(getObj("currentAlertSoundEmbed"))
		getObj("currentAlertSoundEmbed").parentNode.removeChild(getObj("currentAlertSoundEmbed"));
	
	var soundPlayer = document.createElement("embed");
	soundPlayer.setAttribute("id", "currentAlertSoundEmbed");
	soundPlayer.setAttribute("src", optval);
	soundPlayer.setAttribute("autostart", "false");
	soundPlayer.setAttribute("hidden", "true");
	soundPlayer.setAttribute("enablejavascript", true);
	getObj("soundPlayers").appendChild(soundPlayer);
	
	soundPlayer.Play();
}




//
// Bluetooth stuff
//
function checkBTAvailability()
{
	if (FernsehPlugin.canUseBluetooth())
	{
		if (!isCollapsed()) getObj('bluetoothSwitch').style.opacity = 1;
		if ("1" == btDeviceConnnected) getObj('bluetoothSwitch').setAttribute("src", "Images/BT_connected.png");
		else
		{
			if ("1" == btSupport) getObj('bluetoothSwitch').setAttribute("src", "Images/BT_activated.png");
			else getObj('bluetoothSwitch').setAttribute("src", "Images/BT_available.png");
		}
	} else {
		if ("1" == btSupport)
		{
			FernsehPlugin.setBTEnabled(false);
		}
		btSupport = "0";
		btDeviceConnnected = "0";
		//getObj('bluetoothSwitch').setAttribute("src", "Images/BT_notAvailable.png");
		getObj('bluetoothSwitch').style.opacity = 0;
	}
}

function toggleBluetooth()
{
	checkBTAvailability();
	if (("0" == btSupport) && !FernsehPlugin.canUseBluetooth()) 
	{
		FernsehPlugin.beep();
		return;
	}
	if ("0" == btSupport)
	{
		FernsehPlugin.setBTEnabled(true);
	} else {
		FernsehPlugin.setBTEnabled(false);
	}
	// bluetoothServerRunning is being called from the plugin
	// no need to set any variables here
}

function bluetoothServerRunning(flag)
{
	btSupport = flag;
	//getObj('bluetoothSwitch').setAttribute("src", ("1" == flag ? "Images/BT_activated.png" : "Images/BT_available.png"));
	checkBTAvailability();
	widget.setPreferenceForKey(flag, "BluetoothSupport");
}

function btConected(flag)
{
	btDeviceConnnected = flag;
	checkBTAvailability();
	//if ("1" == flag) getObj('bluetoothSwitch').setAttribute("src", "Images/BT_connected.png");
}

function btRequest(request)
{
	//alert("btrequest: "+request);

	// JUST DEBUG
	/*if ((request.length > 2) && (request.substr(0,2) == "++"))
	{
		var tmp = request.substr(2, request.length-2);
		alert(tmp);
		return;
	}*/
	// END DEBUG
	
	if ((request.length > 2) && (request.substr(0,2) == ">="))
	{
		// remote control for EyeTV
		if (eyetvEnabled != "1") return;
		if (!eyeTVIsRunning()) return;
		var tmp = request.substr(2, request.length-2);
		
		var appls = "";
		
		if (tmp == "STAR") appls = "\nif full screen then\nexit full screen\nreturn\nend if\nenter full screen\nend tell";
		if (tmp == "3") appls = " to volume_up";
		if (tmp == "9") appls = " to volume_down";
		if (tmp == "0") appls = " to playpause";
		if (tmp == "1") appls = " to skip backward";
		if (tmp == "7") appls = " to skip forward";
		if (tmp == "POUND") appls = " to quit";
		//alert(appls);
		if ("" != appls) FernsehPlugin.appleScript('tell application "' + appName + '"' + appls);
		
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">>"))
	{
		var channel = request.substr(2, request.length-2);
		switchToEyeTVChannel(channel);
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">W"))
	{
		var url = request.substr(2, request.length-2);
		openURL(url);
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">#"))
	{
		var toggle = request.substr(2, request.length-2);
		eval(toggle);
		return;
	}
	wasBTRequest = true;

	if ((request.length > 2) && (request.substr(0,2) == ">+"))
	{
		var req = request.substr(2, request.length-2);
		getShowDescription(req, undefined);
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">?"))
	{
		var req = request.substr(2, request.length-2);
		getObj("searchInput").value = req;
		searchInCache();
		return;
	}

	if (isCollapsed())
	{
		toggleWidget();
	}
	
	if ("FilteredShows" == request)
	{
		showFiltered();
		return;
	}
	if ("Alarms" == request)
	{
		showAlarms();
		return;
	}

	if ("next" == request)
	{
		showNext();
		return;
	}
	if ("previous" == request)
	{
		showPrevious();
		return;
	}
	
	var options = request.split("|");
	
	var day = options[0];
	var hour = options[1];
	var channel = options[2];
	
	if ("primetime" == hour)
	{
		// Primetime CH: 20.00
		//          D/A: 20.15
		if ("CH" == currentLocale()) hour = "20.00";
		else hour = "20.15";
	}
	
	var channels;
	if ("main" == channel) channels = channels_main;
	else if ("two" == channel) channels = channels_two;
	else channels = mergeHashes(channels_main, channels_two);
	
	prepareShowsAndDisplay(channels, hour, day, "single");
}
